package org.processmining.xlu.ageneral;

import java.util.ArrayList;
import java.util.Collections;
import java.util.List;

public class UtilMathRandom {

	/**
	 * This function generates n unique integers between [min, max).
	 * 
	 * @param min
	 * @param max
	 * @param n
	 * @return A list of unique integers.
	 */
	public static List<Integer> getRandomUniqueInt(int min, int max, int n) {
		List<Integer> res = new ArrayList<Integer>();

		// Generate all int between min and max
		ArrayList<Integer> list = new ArrayList<Integer>();
		for (int i = min; i < max; i++) {
			list.add(i);
		}
		Collections.shuffle(list);
		// Add the first n numbers to the returning list
		for (int i = 0; i < n; i++) {
			res.add(list.get(i));
		}
		return res;
	}

	/**
	 * This function generates n unique integers between [0, max).
	 * 
	 * @param max
	 * @param n
	 * @return A list of unique integers.
	 */
	public static List<Integer> getRandomUniqueInt(int max, int n) {
		return getRandomUniqueInt(0, max, n);
	}

	public static List<Integer> getRandomUniqueInt(int max) {
		ArrayList<Integer> list = new ArrayList<Integer>();
		for (int i = 0; i < max; i++) {
			list.add(i);
		}
		Collections.shuffle(list);
		return list;
	}

}
