//package org.processmining.xlu.experiment.alignment;
//
//import java.io.File;
//import java.io.FileWriter;
//import java.io.IOException;
//import java.io.Writer;
//import java.text.SimpleDateFormat;
//import java.util.Date;
//import java.util.HashSet;
//
//import nl.tue.astar.AStarException;
//
//import org.deckfour.xes.classification.XEventClasses;
//import org.deckfour.xes.classification.XEventClassifier;
//import org.deckfour.xes.classification.XEventNameClassifier;
//import org.deckfour.xes.extension.std.XConceptExtension;
//import org.deckfour.xes.extension.std.XLifecycleExtension;
//import org.deckfour.xes.in.XesXmlGZIPParser;
//import org.deckfour.xes.model.XEvent;
//import org.deckfour.xes.model.XLog;
//import org.deckfour.xes.model.XTrace;
//import org.processmining.contexts.uitopia.UIPluginContext;
//import org.processmining.contexts.uitopia.annotations.UITopiaVariant;
//import org.processmining.framework.connections.ConnectionCannotBeObtained;
//import org.processmining.framework.plugin.annotations.Plugin;
//import org.processmining.framework.plugin.annotations.PluginVariant;
//import org.processmining.models.graphbased.directed.petrinet.Petrinet;
//import org.processmining.models.semantics.petrinet.Marking;
//import org.processmining.partialorder.models.replay.POSyncReplayResult;
//import org.processmining.partialorder.plugins.replay.PartialOrderILPLinearAlg;
//import org.processmining.partialorder.ptrace.param.PAlignmentParameter;
//import org.processmining.partialorder.ptrace.param.PTraceParameter.PTraceType;
//import org.processmining.plugins.InductiveMiner.mining.MiningParameters;
//import org.processmining.plugins.InductiveMiner.mining.MiningParametersIMi;
//import org.processmining.plugins.InductiveMiner.plugins.IMPetriNet;
//import org.processmining.plugins.connectionfactories.logpetrinet.TransEvClassMapping;
//import org.processmining.plugins.petrinet.replayer.algorithms.IPNPartialOrderAwareReplayAlgorithm;
//import org.processmining.plugins.petrinet.replayer.algorithms.costbasedcomplete.CostBasedCompleteParam;
//import org.processmining.plugins.petrinet.replayresult.PNRepResult;
//import org.processmining.plugins.petrinet.replayresult.StepTypes;
//import org.processmining.plugins.pnml.exporting.PnmlExportNetToEPNML;
//import org.processmining.plugins.replayer.replayresult.SyncReplayResult;
//import org.processmining.pnetreplayer.utils.TransEvClassMappingUtils;
//import org.processmining.xlu.matching.zexperiment.ExprReplayUtils;
//import org.processmining.xlu.matching.zexperiment.model.QualityTFPN;
//
//import com.csvreader.CsvWriter;
//
///** --------------------------------------------------------------------------------
// * 
// * This class provides the plugins (functions) that execute four experiments.
// * 
// * (1) To execute the four experiments in the paper "Conformance checking based
// * on partially ordered event data" published in BPM2014 SBP workshop, please
// * check out the version 15231. Or check out the same class in the
// * EnrichedLogReplayer package.
// * 
// * @author xlu
// * 
// * ------------------------------------------------------------------------------- */
//
//@Plugin(name = "Trace Mapping Expriment - Alignment BaseLine", returnLabels = { "Experiment", "Exp" }, returnTypes = {
//		PNRepResult.class, PNRepResult.class }, parameterLabels = { "Petri net", "Event Log" })
//public class ExperimentSBP extends Experiment {
//
//	private int[] expparam;
//	CsvWriter csvWriter;
//	CsvWriter performanceWriter;
//
//	@UITopiaVariant(affiliation = UITopiaVariant.EHV, uiLabel = UITopiaVariant.USEVARIANT, author = "Xixi Lu",
//			email = "x.lu@tue.nl")
//	@PluginVariant(variantLabel = "Trace Mapping Expriment - discovery", requiredParameterLabels = {})
//	public PNRepResult[] runOld(final UIPluginContext context) throws Exception {
//		String filename = "Discovery_";
//		csvWriter = initWriter(filename);
//		XesXmlGZIPParser parser = new XesXmlGZIPParser();
//
//		for (int numNoise = 1; numNoise < 6; numNoise++) {
//			//		int numNoise = 5;
//			//		int numRepeat = 1;
//			for (int numRepeat = 1; numRepeat < 6; numRepeat++) {
//
//				XLog log = parser.parse(new File("./exp2logs/SBP_N" + numNoise + "R" + numRepeat + ".xes.gz")).get(0);
//				//				addDuplicatedLabels(log);
//
//				runExperiment(context, numNoise, numRepeat, log, log);
//			}
//		}//for numNoise
//			//		out.close();
//			//		resfile.close();
//		return null;
//	}
//
//	@UITopiaVariant(affiliation = UITopiaVariant.EHV, uiLabel = UITopiaVariant.USEVARIANT, author = "Xixi Lu",
//			email = "x.lu@tue.nl")
//	@PluginVariant(variantLabel = "Trace Mapping Expriment - old", requiredParameterLabels = { 0 })
//	public PNRepResult[] runOldDisc(final UIPluginContext context, XLog log) throws Exception {
//		String filename = "Discovery_";
//		csvWriter = initWriter(filename);
//		XesXmlGZIPParser parser = new XesXmlGZIPParser();
//		//
//		//		for (int numNoise = 1; numNoise < 6; numNoise++) {
//		int numNoise = 0;
//		int numRepeat = 0;
//		//			for (int numRepeat = 1; numRepeat < 6; numRepeat++) {
//
//		//				XLog log = parser.parse(new File("./exp2logs/SBP_N" + numNoise + "R" + numRepeat + ".xes.gz")).get(0);
//		//				addDuplicatedLabels(log);
//
//		runExperiment(context, numNoise, numRepeat, log, log);
//		//			}
//		//		}//for numNoise
//		//					out.close();
//		//		resfile.close();
//		return null;
//	}
//	
//	
//	/* --------------------------------------------------------------------------------
//
//	@UITopiaVariant(affiliation = UITopiaVariant.EHV, uiLabel = UITopiaVariant.USEVARIANT, author = "Xixi Lu",
//			email = "x.lu@tue.nl")
//	@PluginVariant(variantLabel = "Trace Mapping Expriment - ActiCluster", requiredParameterLabels = {})
//	public PNRepResult[] runClusters(final UIPluginContext context) throws Exception {
//		String filename = "Cluster_";
//		csvWriter = initWriter(filename);
//
//		XesXmlGZIPParser parser = new XesXmlGZIPParser();
//		for (int numNoise = 1; numNoise < 6; numNoise++) {
//			//		int numNoise = 5;
//			//		int numRepeat = 1;
//			for (int numRepeat = 1; numRepeat < 6; numRepeat++) {
//				XLog log = parser.parse(new File("./exp2logs/SBP_N" + numNoise + "R" + numRepeat + ".xes.gz")).get(0);
//
//				// Add duplicated labels
//				//addDuplicatedLabels(log);
//
//				cluster2(context, numNoise, numRepeat, log);
//
//			}
//		}//for numNoise
//			//		out.close();
//			//		resfile.close();
//		return null;
//	}
//
//	@UITopiaVariant(affiliation = UITopiaVariant.EHV, uiLabel = UITopiaVariant.USEVARIANT, author = "Xixi Lu",
//			email = "x.lu@tue.nl")
//	@PluginVariant(variantLabel = "Trace Mapping Expriment - ActiCluster - MU", requiredParameterLabels = { 0 })
//	public void runClusterMU(final UIPluginContext context, XLog log) throws IOException, OperationCancelledException,
//			ConnectionCannotBeObtained, AStarException {
//		String filename = "Cluster_";
//		csvWriter = initWriter(filename);
//		//		NewEGMatchTestPluginMUDataSetImpl.preprocessAndUpdateLogForExperiment(log);
//
//		cluster2(context, 0, 0, log);
//	}
//
//	private void cluster2(final UIPluginContext context, int numNoise, int numRepeat, XLog log) throws IOException,
//			OperationCancelledException, ConnectionCannotBeObtained, AStarException {
//		long s = System.currentTimeMillis();
//
//		// Get clusters
//		ParametersWizard conf = new ParametersWizard(context);
//		//				conf.show();
//
//		// Create a new Clusterer
//		Clusterer clusterer;
//
//		PanelOne panel_one = new PanelOne();
//		ParametersPanel panel_two = new ParametersPanel();
//		//				ATCParameters atcParameters = conf.getATCParameters();
//		ATCParameters atcParameters = panel_one.getMDTCParameters();
//		//				HeuristicsMinerSettings heuristicsMinerSettings = conf.getHeuristicsMinerSettings();
//		HeuristicsMinerSettings settings = panel_two.getSettings();
//		//		atcParameters.setStopNbGroups(2);
//		settings.setClassifier(new XEventNameClassifier());
//
//		// Assign a ClustererEventListenerUI-object that is linked to the
//		// current context to the Clusterer
//		ClustererEventListener eventListener = new ClustererEventListenerUI(context, log, atcParameters);
//
//		if (atcParameters.isGreedy()) {
//
//			clusterer = new GreedyClusterer(log, atcParameters, settings, eventListener);
//		} else {
//
//			clusterer = new GreedyDistanceClusterer(log, atcParameters, settings, eventListener);
//		}
//
//		// Start calculations
//		clusterer.cluster();
//
//		// Return the result
//		ActiTraCClustering clusters = clusterer.getClustering();
//
//		for (Cluster cluster : clusters.getTree()) {
//			XLog clusterlog = cluster.getInternalLog();
//			clusterlog.addAll(cluster.getExternalLog());
//
//			System.out.println("Cluster " + XConceptExtension.instance().extractName(clusterlog) + " has "
//					+ clusterlog.size());
//
//			//					if (clusterlog.size() < 800) {
//			runExperiment(context, numNoise, numRepeat, clusterlog, clusterlog);
//			//					}
//
//		}
//
//		long e = System.currentTimeMillis();
//		double runtime = (e - s) / 1000.0 / 60.0;
//		this.performanceWriter.writeRecord(new String[] { String.valueOf(numNoise), String.valueOf(numRepeat),
//				String.valueOf(runtime) });
//		this.performanceWriter.flush();
//	}
//
//	@UITopiaVariant(affiliation = UITopiaVariant.EHV, uiLabel = UITopiaVariant.USEVARIANT, author = "Xixi Lu",
//			email = "x.lu@tue.nl")
//	@PluginVariant(variantLabel = "Trace Mapping Expriment - GuideTreeCluster", requiredParameterLabels = {})
//	public PNRepResult[] runGuideTreeCluster(final UIPluginContext context) throws Exception {
//		String filename = "GuideTreeCluster_";
//		csvWriter = initWriter(filename);
//		//		context.setFuture(new PluginExecutionResultImpl(null, null, null));
//		XesXmlGZIPParser parser = new XesXmlGZIPParser();
//
//		GuideTreeMinerUI guideTreeMinerUI = new GuideTreeMinerUI(context);
//		GuideTreeMinerInput input = null;
//
//		for (int numNoise = 1; numNoise < 6; numNoise++) {
//			//		int numNoise = 1;
//			//					int numRepeat = 1;
//
//			for (int numRepeat = 1; numRepeat < 6; numRepeat++) {
//				XLog log = parser.parse(new File("./exp2logs/SBP_N" + numNoise + "R" + numRepeat + ".xes.gz")).get(0);
//
//				// Add duplicated labels
//				//				addDuplicatedLabels(log);
//				updateTransitionLifeCycle(log);
//				if (input == null) {
//					input = guideTreeMinerUI.mineTree(log);
//				}
//
//				//				MineGuideTree tree = new MineGuideTree();
//				//				GuideTreeMinerInput input = new GuideTreeMinerInput();
//				//				input.setFeatureType(GTMFeatureType.Sequence);
//				//				Object[] res = tree.mine(context, input, log);
//
//				//				GuideTreeMinerPlugin plugin = new GuideTreeMinerPlugin();
//				//			Object[] res = GuideTreeMinerPlugin.main(context, log);
//
//				long s = System.currentTimeMillis();
//				Object[] res = GuideTreeMinerPlugin.main(context, log, input);
//
//				ClusterLogOutput clusters = (ClusterLogOutput) res[1];
//
//				for (XLog clusterlog : clusters.clusterLogList()) {
//					//					XLog clusterlog = cluster.getInternalLog();
//					//					clusterlog.addAll(cluster.getExternalLog());
//
//					System.out.println("Cluster " + XConceptExtension.instance().extractName(clusterlog) + " has "
//							+ clusterlog.size());
//
//					//					if (clusterlog.size() < 800) {
//					runExperiment(context, numNoise, numRepeat, clusterlog, clusterlog);
//					//					}
//
//				}
//
//				long e = System.currentTimeMillis();
//				double runtime = (e - s) / 1000.0 / 60.0;
//				this.performanceWriter.writeRecord(new String[] { String.valueOf(numNoise), String.valueOf(numRepeat),
//						String.valueOf(runtime) });
//				this.performanceWriter.flush();
//
//			}
//		}//for numNoise
//		//		out.close();
//		//		resfile.close();
//		return null;
//	}
//	
//	
//
//	@UITopiaVariant(affiliation = UITopiaVariant.EHV, uiLabel = UITopiaVariant.USEVARIANT, author = "Xixi Lu",
//			email = "x.lu@tue.nl")
//	@PluginVariant(variantLabel = "Trace Mapping Expriment - GuideTreeCluster - MU", requiredParameterLabels = { 0 })
//	public PNRepResult[] runGuideTreeClusterMUData(final UIPluginContext context, XLog log) throws Exception {
//		String filename = "GuideTreeCluster_";
//		csvWriter = initWriter(filename);
//
//		//		NewEGMatchTestPluginMUDataSetImpl.preprocessAndUpdateLogForExperiment(log);
//
//		//		updateTransitionLifeCycle(log);
//		//
//		Object[] res = GuideTreeMinerPlugin.main(context, log);
//
//		ClusterLogOutput clusters = (ClusterLogOutput) res[1];
//		//
//		for (XLog clusterlog : clusters.clusterLogList()) {
//			//
//			//			System.out.println("Cluster " + XConceptExtension.instance().extractName(clusterlog) + " has "
//			//					+ clusterlog.size());
//
//			runExperiment(context, 0, 0, clusterlog, clusterlog);
//
//		}
//
//		return null;
//	}
//	
//	 * 
//	 * ------------------------------------------------------------------------------- */
//
//	private void runExperiment(final UIPluginContext context, int numNoise, int numRepeat, XLog modelLog, XLog alignLog)
//			throws ConnectionCannotBeObtained, AStarException, IOException {
//		XEventClassifier classifier = new XEventNameClassifier();
//		//		XEventClassifier classifier = new XEventAttributeClassifier("Org", "Verrichttekst_1");		
//		XEventClasses classes = XEventClasses.deriveEventClasses(classifier, alignLog);
//
//		MiningParameters param = new MiningParametersIMi();
//		//
//		for (float t = (float) 0.2; t < 1.01; t += 0.1) {
//			param.setNoiseThreshold(t);
//			//		float t = (float) 2.0;
//			//			Object[] nets = Experiment.minePetrinetUsingHeuristicminer(context, modelLog);
//
//			long startTime = System.currentTimeMillis();
//			param.setClassifier(classifier);
//			Object[] nets = IMPetriNet.minePetriNet(context, modelLog, param);
//
//			PnmlExportNetToEPNML pnmlSerializer = new PnmlExportNetToEPNML();
//			pnmlSerializer.exportPetriNetToEPNMLFile(context, (Petrinet) nets[0], new File("./results/nets/Net" + t
//					+ ".pnml"));
//
//			QualityTFPN res = executeExperiment(context, nets, alignLog, classes, PTraceType.Sequential_Dependency,
//					numNoise, numRepeat);
//
//			long stopTime = System.currentTimeMillis();
//			double elapsedTime = (stopTime - startTime) / 1000.0 / 60.0;
//
//			this.csvWriter.writeRecord(getResultRecord(numNoise, numRepeat, t, XConceptExtension.instance()
//					.extractName(modelLog), modelLog.size(), PTraceType.Sequential_Dependency, res, elapsedTime));
//			this.csvWriter.flush();
//
//			//					res = executeExperiment(context, nets, log, classes, PTraceType.Data_Dependency, numNoise, numRepeat);
//			//					this.csvWriter.writeRecord(getResultRecord(numNoise, numRepeat, t,
//			//							PTraceType.Data_Dependency, res));
//			//					this.csvWriter.flush();
//		}
//	}
//
//	private void updateTransitionLifeCycle(XLog log) {
//		for (XTrace t : log) {
//			for (XEvent e : t) {
//				String name = XLifecycleExtension.instance().extractTransition(e);
//				if (name == null) { // "Re-eval"
//					XLifecycleExtension.instance().assignTransition(e, "Complete");
//				}
//			}
//		}
//	}
//
//
//
//	private CsvWriter initWriter(String filename) throws IOException {
//		long yourmilliseconds = System.currentTimeMillis();
//		SimpleDateFormat sdf = new SimpleDateFormat("MMMdd-HHmmss");
//		Date resultdate = new Date(yourmilliseconds);
//		String runday = sdf.format(resultdate);
//
//		Writer fileWriter = new FileWriter(new File("./results/" + filename + runday + ".csv"));
//		performanceWriter = new CsvWriter(new FileWriter(new File("./results/Perf_" + filename + ".csv")), ';');
//		return new CsvWriter(fileWriter, ';');
//	}
//
//	//	@UITopiaVariant(affiliation = UITopiaVariant.EHV, uiLabel = UITopiaVariant.USEVARIANT, author = "Xixi Lu",
//	//			email = "x.lu@tue.nl")
//	//	@PluginVariant(variantLabel = "Trace Mapping Expriment - Alignment BaseLine G2", requiredParameterLabels = { 0 })
//	//	public PNRepResult run(final UIPluginContext context, Petrinet net) throws Exception {
//	//		long yourmilliseconds = System.currentTimeMillis();
//	//		SimpleDateFormat sdf = new SimpleDateFormat("MMMdd-HHmmss");
//	//		Date resultdate = new Date(yourmilliseconds);
//	//		String runday = sdf.format(resultdate);
//	//
//	//		XesXmlGZIPParser parser = new XesXmlGZIPParser();
//	//
//	//		Writer fileWriter = new FileWriter(new File(
//	//				"./results/Discovery_AlignmentRes_" + runday + ".csv"));
//	//		csvWriter = new CsvWriter(fileWriter, ';');
//	//
//	//		for (int numNoise = 5; numNoise < 6; numNoise++) {
//	//			for (int numRepeat = 1; numRepeat < 6; numRepeat++) {
//	//
//	//				// Only for graph2~!!!!!
//	//				XLog log = parser.parse(
//	//						new File("./exp2logs/SBP_N" + numNoise + "R"
//	//								+ numRepeat + ".xes.gz")).get(0);
//	//
//	//				MiningParameters param = new MiningParametersIMi();
//	//
//	//				for (float t = (float) 0.0; t <= 1.0; t += 0.1) {
//	//					param.setNoiseThreshold(t);
//	//					Object[] nets = IMPetriNet.minePetriNet(context, log, param);
//	//					executeConformanceCheck(context, (Petrinet)nets[0], numNoise, numRepeat, log, t);
//	//				}
//	//			}
//	//		}
//	//		//		out.close();
//	//		//		resfile.close();
//	//		return null;
//	//	}
//	//
//	//	private void executeConformanceCheck(final UIPluginContext context, Petrinet net, int numNoise, int numRepeat,
//	//			XLog log, float threshold) throws ConnectionCannotBeObtained, AStarException, IOException {
//	////		configurations = getConfiguration(context, net, log);
//	////		TransEvClassMapping mapping = (TransEvClassMapping) configurations[PNReplayerUI.MAPPING];
//	//
//	//		QualityTFPN res = executeExperiment(context, net, log, mapping, PTraceType.Sequential_Dependency, numNoise,
//	//				numRepeat);
//	//		this.csvWriter.writeRecord(getResultRecord(numNoise, numRepeat, threshold, PTraceType.Sequential_Dependency, res));
//	//		this.csvWriter.flush();
//	//
//	//		res = executeExperiment(context, net, log, mapping, PTraceType.Data_Dependency, numNoise, numRepeat);
//	//		this.csvWriter.writeRecord(getResultRecord(numNoise, numRepeat, threshold, PTraceType.Data_Dependency, res));
//	//		this.csvWriter.flush();
//	//	}
//
//	private String[] getResultRecord(int numNoise, int numRepeat, float threshold, String logName, int logSize,
//			PTraceType type, QualityTFPN res, double elapsedTime) {
//		return new String[] { String.valueOf(numNoise), String.valueOf(numRepeat), String.valueOf(threshold), logName,
//				String.valueOf(logSize), String.valueOf(type), String.valueOf(res.truePositiveNoise),
//				String.valueOf(res.falsePositiveNoise), String.valueOf(res.falseNegativeNoise),
//				String.valueOf(res.trueNegativeNoise), String.valueOf(elapsedTime) };
//	}
//
//	private QualityTFPN executeExperiment(UIPluginContext context, Object[] nets, XLog testLog, XEventClasses classes,
//			PTraceType type, int numNoise, int numRepeat) throws ConnectionCannotBeObtained, AStarException,
//			IOException {
//		PAlignmentParameter param = new PAlignmentParameter();
//		param.setType(type);
//		//		printParam(System.currentTimeMillis());
//
//		IPNPartialOrderAwareReplayAlgorithm selectedAlg = new PartialOrderILPLinearAlg();
//		Petrinet net = (Petrinet) nets[0];
//
//		TransEvClassMapping mapping = TransEvClassMappingUtils.getInstance().getMapping(net,
//				new HashSet<>(classes.getClasses()), classes.getClassifier());
//		Marking initM = (Marking) nets[1];
//		Marking finalM = (Marking) nets[2];
//		//		IPNReplayParameter algParameters = (IPNReplayParameter) configurations[PNReplayerUI.PARAMETERS];
//		CostBasedCompleteParam algParameters = ExprReplayUtils.getCostBasedCompleteParam(initM, finalM, classes,
//				mapping, 1, 10000);
//
//		PNRepResult res1 = runTest(context, net, testLog, param, selectedAlg, algParameters, mapping);
//		//				(context, net, testLog, param );
//
//		for (SyncReplayResult res : res1) {
//			POSyncReplayResult posrr = (POSyncReplayResult) res;
//			if (posrr.getStepTypes().size() != posrr.getPOAlignmentGraph().getMoves().size()
//					|| posrr.getNodeInstance().size() < 5) {
//				try {
//					throw new Exception("Moves removed before compute metric");
//				} catch (Exception e) {
//					e.printStackTrace();
//				}
//			}
//		}
//		QualityTFPN logMetric1 = computeComplexMetricOfLog(testLog, res1, mapping, param);
//		//		EGFusionTest.printSystemResult(null, 0, logMetric1);
//
//		//		System.out.println("");
//		//		printMetric(resfile, logMetric1);
//		return logMetric1;
//	}
//
//	private QualityTFPN computeComplexMetricOfLog(XLog testLog, PNRepResult res, TransEvClassMapping mapping,
//			PAlignmentParameter param) {
//
//		QualityTFPN logMetric = new QualityTFPN();
//
//		/* Compared to the known result */
//		for (SyncReplayResult srr : res) {
//			POSyncReplayResult posrr = (POSyncReplayResult) srr;
//
//			for (int traceIndex : posrr.getTraceIndex()) {
//				//				out.println("Trace " + traceIndex + " measure : =================");
//				XTrace newTrace = testLog.get(traceIndex);
//
//				computeComplexMetricOfTrace(traceIndex, newTrace, posrr, mapping, param, logMetric);
//
//				//				printMetric(out, traceMetric);
//				//				logMetric.addTraceMetric(traceIndex, traceMetric);
//			}
//		}
//		return logMetric;
//
//	}
//
//	private void computeComplexMetricOfTrace(int traceIndex, XTrace newTrace, POSyncReplayResult posrr,
//			TransEvClassMapping mapping, PAlignmentParameter param, QualityTFPN logMetric) {
//
//		for (int i = 0; i < posrr.getStepTypes().size(); i++) {
//			StepTypes stepType = posrr.getStepTypes().get(i);
//			int newEventIndex = posrr.getIndeces().get(i);
//			if (newEventIndex < 0) {
//				if (stepType.equals(StepTypes.MINVI)) {
//					// ok
//					continue;
//				} else {
//					System.out.println("Errorooorororororor");
//					continue;
//				}
//			}
//			XEvent e = newTrace.get(newEventIndex);
//
//			if (stepType.equals(StepTypes.L)) {
//				if (XExperimentNoiseExtension.isNoise(e)) {
//					logMetric.truePositiveNoise++;
//				} else {
//					logMetric.falsePositiveNoise++;
//					//					System.out.println("Trace " + traceIndex + " event " + i + " false positive noise");
//				}
//			} else if (stepType.equals(StepTypes.LMGOOD)) {
//				if (XExperimentNoiseExtension.isNoise(e)) {
//					logMetric.falseNegativeNoise++;
//					//					System.out.println("Trace " + traceIndex + " event " + i + " false negative noise");
//				} else {
//					logMetric.trueNegativeNoise++;
//				}
//			} else {
//				System.out.println("Errorooorororororor");
//			}
//
//		}
//
//	}
//
//}
