package org.processmining.xlu.experiment.discovery;

import org.deckfour.xes.classification.XEventClassifier;
import org.deckfour.xes.model.XLog;
import org.processmining.framework.plugin.PluginContext;

public interface ExpDiscoveryAlgorithm {

	/**
	 * This functions mines a petri net from the given log using
	 * XEventNameClassifier, including the initial marking and final marking(s).
	 * Moreover, the function adds the connections to the markings to the plugin
	 * context.
	 * 
	 * @param context
	 * @param log
	 * @return
	 */
	public MarkedPetrinet minePetrinet(PluginContext context, XLog log);

	public MarkedPetrinet minePetrinet(PluginContext context, XLog log,
			XEventClassifier classifier);
	
	
	
}
