package org.processmining.xlu.experiment.discovery;

import java.util.Iterator;

import org.deckfour.xes.classification.XEventClassifier;
import org.deckfour.xes.model.XAttribute;
import org.deckfour.xes.model.XEvent;
import org.deckfour.xes.model.XLog;
import org.deckfour.xes.model.XTrace;
import org.deckfour.xes.model.impl.XAttributeLiteralImpl;
import org.processmining.models.graphbased.directed.petrinet.Petrinet;
import org.processmining.models.graphbased.directed.petrinet.PetrinetEdge;
import org.processmining.models.graphbased.directed.petrinet.PetrinetNode;
import org.processmining.models.graphbased.directed.petrinet.elements.Place;
import org.processmining.models.graphbased.directed.petrinet.elements.Transition;
import org.processmining.models.semantics.petrinet.Marking;

public class ExpDiscoveryDummyEndUtil {

	public static XLog addDummyEndEvents(XLog log, XEventClassifier classifier) {
		XLog clone = (XLog) log.clone();
		for (XTrace t : clone) {
			XEvent e = (XEvent) t.get(t.size() - 1).clone();

			for (String key : classifier.getDefiningAttributeKeys()) {
				XAttribute a = new XAttributeLiteralImpl(key, "DUMMYEND");
				e.getAttributes().put(key, a);
			}

			t.add(e);
		}
		return clone;
	}

	public static Marking removeDummyEndTransitionAndReturnFinalMarking(Petrinet net) {
		Marking finalmarking = new Marking();
		Transition end = null;
		for (Transition t : net.getTransitions()) {
			if (t.getLabel().contains("DUMMYEND")) {
				end = t;
				break;
			}
		}
		Iterator<PetrinetEdge<? extends PetrinetNode, ? extends PetrinetNode>> i = net
				.getInEdges(end).iterator();
		while (i.hasNext()) {
			PetrinetEdge<? extends PetrinetNode, ? extends PetrinetNode> inEdge = i
					.next(); // must be called before you can call i.remove()
			// Do something
			Place p = (Place) inEdge.getSource();
			finalmarking.add(p);

			i.remove();
		}

		i = net.getOutEdges(end).iterator();
		while (i.hasNext()) {
			PetrinetEdge<? extends PetrinetNode, ? extends PetrinetNode> outEdge = i
					.next(); // must be called before you can call i.remove()
			// Do something
			Place p = (Place) outEdge.getTarget();
			net.removePlace(p);

			i.remove();
		}

		net.removeTransition(end);
		return finalmarking;
	}
}
