package org.processmining.xlu.experiment.discovery;

import java.util.Collection;

import org.processmining.framework.plugin.PluginContext;
import org.processmining.models.connections.petrinets.behavioral.FinalMarkingConnection;
import org.processmining.models.connections.petrinets.behavioral.InitialMarkingConnection;
import org.processmining.models.graphbased.directed.petrinet.PetrinetGraph;
import org.processmining.models.graphbased.directed.petrinet.elements.Place;
import org.processmining.models.semantics.petrinet.Marking;

/**
 * NOT USED
 * 
 * @author xlu
 *
 */
public class MarkingFactory {

	/**
	 * Create initial marking and create the corresponding connection and add
	 * both the marking and connection to the context.
	 * 
	 * @param context
	 * @param net
	 * @param initMarking
	 * @return
	 */
	public static Object[] constructInitMarking(PluginContext context, PetrinetGraph net,
			Marking initMarking) {
		checkMarking(net, initMarking);
		InitialMarkingConnection conn = new InitialMarkingConnection(net, initMarking);
		context.getFutureResult(0).setLabel(
				"Connection init marking of " + net.getLabel());
		context.getFutureResult(1).setLabel("Init marking of " + net.getLabel());
		context.addConnection(conn);
		return new Object[] { conn, initMarking };
	}

	/**
	 * Create final marking and create the corresponding connection and add both
	 * the marking and connection to the context.
	 * 
	 * @param context
	 * @param net
	 * @param finalMarking
	 * @return
	 */
	public Object[] constructFinalMarking(PluginContext context, PetrinetGraph net,
			Marking finalMarking) {
		checkMarking(net, finalMarking);
		FinalMarkingConnection conn = new FinalMarkingConnection(net, finalMarking);
		context.getFutureResult(0).setLabel(
				"Connection final marking of " + net.getLabel());
		context.getFutureResult(1).setLabel("Final marking of " + net.getLabel());
		context.addConnection(conn);
		return new Object[] { conn, finalMarking };
	}

	private static void checkMarking(PetrinetGraph net, Marking initMarking) {
		if (initMarking == null) {
			throw new IllegalArgumentException("No marking is provided");
		}

		Collection<Place> colPlaces = net.getPlaces();
		for (Place p : initMarking) {
			if (!colPlaces.contains(p)) {
				throw new IllegalArgumentException(
						"Marking contains places outside of the net");
			}
		}
	}
}
