package org.processmining.xlu.experiment.mu;

import java.util.Arrays;

import org.deckfour.xes.extension.std.XConceptExtension;
import org.deckfour.xes.factory.XFactory;
import org.deckfour.xes.factory.XFactoryRegistry;
import org.deckfour.xes.model.XAttribute;
import org.deckfour.xes.model.XEvent;
import org.deckfour.xes.model.XLog;
import org.deckfour.xes.model.XTrace;
import org.processmining.xlu.experiment.alignment.XExperimentNoiseExtension;

public class MUDATAPreprocess {

	public static String[] MU_Noises = new String[] { "1e consult algemeen",
			"Vervolgconsult algemeen" };
	public static String[] MU_RENAME_TEST = new String[] { "Na OK consult",
			"1e_oogl.-extracaps.extract. impl.lens a.o.k", "Na 2eOK consult",
			"2e_oogl.-extracaps.extract. impl.lens a.o.k",
			"2e_ooglens-cataractop.extracaps.inbr.kunstl",
			"1e_ooglens-cataractop.extracaps.inbr.kunstl", "Oog meting consult" };

	public static String[] MU_TEST = new String[] { "cornea-corneatopografie",
			"retina-OCT", "oog-IOL-master" };

	public static XLog updateMUDataLog1econsult(XLog log) {
		XFactory factory = XFactoryRegistry.instance().currentDefault();
		for (XTrace t : log) {

//			boolean testConsults = false;
			for (int i = 0; i < t.size(); i++) {
				XEvent event = t.get(i);
				if (XConceptExtension.instance().extractName(event)
						.equals("1e consult algemeen")) {
					XConceptExtension.instance().assignName(event,
							"Vervolgconsult algemeen");
				}
				if (XConceptExtension.instance().extractName(event)
						.equals("oogl.-extracaps.extract. impl.lens a.o.k")) {
					XConceptExtension.instance().assignName(event,
							"ooglens-cataractop.extracaps.inbr.kunstl");
				}
			}
		}
		return log;
	}

	public static XLog updateMUDataLog(XLog log) {
		XFactory factory = XFactoryRegistry.instance().currentDefault();
		for (XTrace t : log) {

			boolean testConsults = false;
			for (int i = 0; i < t.size(); i++) {
				XEvent event = t.get(i);

				// Needed to rename "Consulting" events to be mapped to each other...
				XAttribute a = event.getAttributes().get("Verrichttekst_1");
//				if (a instanceof XAttributeLiteral) {
//					String label = ((XAttributeLiteral) a).getValue();
//					if (label.equals("1e consult algemeen")) {
//						XAttribute newA = factory.createAttributeLiteral("Verrichttekst_1", "Vervolgconsult algemeen",
//								null);
//						event.getAttributes().put(newA.getKey(), newA);
//					}
//				}

				// Using XExperimentNoiseExtension to create the TRUE attributes for TP evaluations
				String label = XConceptExtension.instance().extractName(event);
				XAttribute trueLabelAttr = null;
				if (label.equals(MU_Noises[0]) || label.equals(MU_Noises[1])) {
					trueLabelAttr = XExperimentNoiseExtension.getTrueNoiseAttr();
				} else {

					if (Arrays.asList(MU_RENAME_TEST).contains(label)) {
						testConsults = true;
					} else if (Arrays.asList(MU_TEST).contains(label)) {
						if (testConsults) {
							trueLabelAttr = XExperimentNoiseExtension.getTrueNoiseAttr();
						}
					}
				}
				if (trueLabelAttr == null) {
					trueLabelAttr = XExperimentNoiseExtension.getTrueLabelAttr(label);
				}
				event.getAttributes().put(trueLabelAttr.getKey(), trueLabelAttr);
			}
		}
		return log;

	}

}
