//package org.processmining.xlu.logrepair.plugins;
//
//import java.util.ArrayList;
//import java.util.Collections;
//import java.util.Comparator;
//import java.util.HashMap;
//import java.util.List;
//import java.util.Map;
//import java.util.Map.Entry;
//import java.util.Set;
//
//import org.deckfour.xes.model.XEvent;
//import org.deckfour.xes.model.XLog;
//import org.deckfour.xes.model.XTrace;
//import org.processmining.contexts.uitopia.annotations.UITopiaVariant;
//import org.processmining.framework.plugin.PluginContext;
//import org.processmining.framework.plugin.annotations.Plugin;
//import org.processmining.framework.plugin.annotations.PluginCategory;
//import org.processmining.framework.plugin.annotations.PluginVariant;
//import org.processmining.xlu.logrepair.plugins.DAnnotatedTrace.Interval;
//import org.processmining.xlu.logrepair.plugins.DAnnotatedTrace.TraceInterval;
//import org.processmining.xlu.matching.models.EEdge;
//import org.processmining.xlu.matching.models.ENode;
//import org.processmining.xlu.matching.models.MatchMapping;
//import org.processmining.xlu.matching.models.RepEGraph;
//import org.processmining.xlu.matching.models.collection.MatchMappings;
//import org.processmining.xlu.matching.models.collection.RepEGraphs;
//import org.processmining.xlu.pgraph.vis.filter.PGraphFilter;
//import org.processmining.xlu.pgraph.vis.filter.PGraphFilterLabelAEventFreqSingleGraphImpl;
//
//@Plugin(name = "Log Repair", returnLabels = { "Repaired Log" }, returnTypes = { XLog.class }, parameterLabels = {
//		"Event Log", "Parameters" }, categories = { PluginCategory.Discovery, PluginCategory.Analytics },
//		keywords = { "Clustering" }, help = "Compute mappings between traces", userAccessible = true)
//public class LogRepairPlugin {
//
//	@UITopiaVariant(affiliation = UITopiaVariant.EHV, author = "Xixi Lu", email = "x.lu@tue.nl",
//			uiLabel = UITopiaVariant.USEVARIANT, pack = "")
//	@PluginVariant(variantLabel = "Log Repair - Seq", requiredParameterLabels = { 0 })
//	public XLog repairLogNoUIStandard(PluginContext context, RepEGraphs regs) {
//		return repairLogMainNaiveSequential(regs, null);
//	}
//
//	public XLog repairLogMainNaiveSequential(RepEGraphs regs, LogRepairConfiguration conf) {
//		XLog log = regs.getLog();
//		XLog fixedLog = (XLog) log.clone();
//		List<DAnnotatedTrace> annotatedTraces = initDeviationAnnotatedTraces(log);
//		MatchMappings mappings = regs.getMappings();
//		
//
//		List<RepEGraph> regGraphs = regs.getGraphs();
//		for (RepEGraph regGraph : regGraphs) {
//
//			// 1. identify infrequent nodes and arcs
//			List<ENode> deviatingNodes = new ArrayList<ENode>();
//			List<EEdge> deviatingEdges = new ArrayList<EEdge>();
//			identifyDeviatingNodesAndEdges(regGraph, conf, deviatingNodes, deviatingEdges);
//
//			// 2. annotate traces
//			annotateDeviations(regGraph, deviatingNodes, deviatingEdges, annotatedTraces);
//
//			// 3. repair by finding the most similar and fitting sub segment. 
//			
//			repairLog(regGraph, annotatedTraces, log, fixedLog, mappings);
//		}
//		return fixedLog;
//	}
//
//	private void repairLog(RepEGraph regGraph, List<DAnnotatedTrace> annotatedTraces, XLog log, XLog fixedLog,
//			MatchMappings mappings) {
//
//		for (Integer traceIndex : regGraph.getRepresentedGraphIds()) {
//
//			// 1. Sort other traces from similar to dissimilar according to their mappings
//			List<Integer> fitTraceIndeces = new ArrayList<Integer>(regGraph.getRepresentedGraphIds());
//			fitTraceIndeces.remove(traceIndex);
//			Collections.sort(fitTraceIndeces, new SimilarTraceComparator(mappings, traceIndex));
//
//			// 2. find similar pattern that is not deviating. 
//			DAnnotatedTrace deviatingTrace = annotatedTraces.get(traceIndex);
//			List<Interval> deviatingIntervals = new ArrayList<Interval>(deviatingTrace.getDeviatingIntervals());
//
//			Map<Interval, TraceInterval> mapDeviation2Fitting = new HashMap<>();
//
//			// 2.1 for each other trace
//			for (Integer fitTraceIndex : fitTraceIndeces) {
//				DAnnotatedTrace fittingTrace = annotatedTraces.get(fitTraceIndex);
//				MatchMapping mapping = mappings.getAnOptimalMapping(traceIndex, fittingTrace.getTraceIndex());
//
//				// 2.2 Find the mapped-to fitting interval in this other trace
//				updateFixingIntervalsAndRemoveFixedOnes(deviatingIntervals, fittingTrace, mapping, mapDeviation2Fitting);
//
//				if (deviatingIntervals.isEmpty()) {
//					break;
//				}
//			}
//
//			// 3. all deviating segments have been mapped to fitting segments. Fix this trace.
//
//			XTrace fixedTrace = fixedLog.get(traceIndex);
//			for (int i = deviatingTrace.getDeviatingIntervals().size() - 1; i >= 0; i--) {
//				// 3.1 remove the deviating segments
//				Interval deviatingInterval = deviatingTrace.getDeviatingIntervals().get(i);
//				int deviatingStartLB = Math.max(deviatingInterval.lowerbound - 1, 0);
//				int deviatingCompleteUP = deviatingInterval.upperbound + 1;
//				for (int j = Math.min(deviatingCompleteUP,
//						fixedTrace.size() - 1); j >= deviatingStartLB; j--) {
//					fixedTrace.remove(j);
//				}
//
//				// 3.2 add the fitting segments
//				TraceInterval fittingInterval = mapDeviation2Fitting.get(deviatingInterval);
//				if (fittingInterval != null) {
//					XTrace orginialFitTrace = log.get(fittingInterval.traceIndex);
//					for (int j = Math.min(fittingInterval.upperbound, orginialFitTrace.size() - 1); j >= fittingInterval.lowerbound; j--) {
//						XEvent newEvent = (XEvent) orginialFitTrace.get(j).clone();
//						fixedTrace.add(deviatingStartLB, newEvent);
//					}
//
//					System.out.println("trace " + traceIndex + " between " + deviatingStartLB + " and "
//							+ deviatingCompleteUP + " replaced by " + " trace " + fittingInterval.traceIndex
//							+ " between " + fittingInterval.lowerbound + " and " + fittingInterval.upperbound);
//				} else {
//					System.err.println("trace " + traceIndex + " between " + deviatingStartLB + " and "
//							+ deviatingCompleteUP + " no fitting segments");
//				}
//			}
//			fixedLog.set(traceIndex, fixedTrace);
//			
//			
//		}
//		
//	}
//
//	/**
//	 * This function finds, for each interval in deviatingIntervals, an fitting
//	 * segment in the fittingTrace. If such a fitting segment exist, this pair
//	 * is stored in mapDeviation2Fitting. The function uses the mapping as
//	 * auxiliary to map deviating interval to fitting intervals.
//	 * 
//	 * @param deviatingIntervals
//	 * @param fittingTrace
//	 * @param mapping
//	 * @param mapDeviation2Fitting
//	 */
//	private void updateFixingIntervalsAndRemoveFixedOnes(List<Interval> deviatingIntervals,
//			DAnnotatedTrace fittingTrace, MatchMapping mapping, Map<Interval, TraceInterval> mapDeviation2Fitting) {
//		//		Map<Interval, Interval> mapDev2Fix = new HashedMap<DAnnotatedTrace.Interval, DAnnotatedTrace.Interval>();
//		//		if(mapping.getSourceGraph().getId() == deviatingTrace.getTraceIndex() && mapping.getTargetGraph().getId() == fittingTrace.getTraceIndex()){		
//		//		} else {
//		//			mapping.inverse();
//		//			System.err.println("need to inverse mapping");
//		//		}
//
//		List<Interval> toBeRemoved = new ArrayList<DAnnotatedTrace.Interval>();
//		for (Interval deviatingInterval : deviatingIntervals) {
//			int nonDeviatingStart = deviatingInterval.lowerbound - 1;
//			int nonDeviatingComplete = deviatingInterval.upperbound + 1;
//
//			Integer mappedFitStart = mapping.getTargetNodeIdMappedTo(nonDeviatingStart);
//			Integer mappedFitComplete = mapping.getTargetNodeIdMappedTo(nonDeviatingComplete);
//
//			boolean mappedSegmentContainedDeviation = testOverlappingIntervals(fittingTrace.getDeviatingIntervals(),
//					mappedFitStart, mappedFitComplete);
//			if (!mappedSegmentContainedDeviation) {
//
////				Interval interval = new Interval(nonDeviatingStart, nonDeviatingComplete);
//				TraceInterval interval2 = new TraceInterval(fittingTrace.getTraceIndex(), mappedFitStart,
//						mappedFitComplete);
//				mapDeviation2Fitting.put(deviatingInterval, interval2);
//				toBeRemoved.add(deviatingInterval);
//			}
//		}
//		deviatingIntervals.removeAll(toBeRemoved);
//	}
//
//	private boolean testOverlappingIntervals(List<Interval> intervals, Integer mappedFitStart, Integer mappedFitComplete) {
//		if (mappedFitStart == null || mappedFitComplete == null || mappedFitComplete < mappedFitStart) {
//			return true;
//		}
//		boolean fitSegmentContainedDeviation = false;
//		for (Interval i : intervals) {
//			if (i.upperbound < mappedFitStart || mappedFitComplete < i.lowerbound) {
//				// no deviation. 
//			} else {
//				fitSegmentContainedDeviation = true;
//				break;
//			}
//		}
//		return fitSegmentContainedDeviation;
//	}
//
//	public class SimilarTraceComparator implements Comparator<Integer> {
//		private MatchMappings mappings;
//		private Integer traceIndex;
//
//		public SimilarTraceComparator(MatchMappings mappings, Integer traceIndex) {
//			this.mappings = mappings;
//			this.traceIndex = traceIndex;
//		}
//
//		public int compare(Integer traceIndex1, Integer traceIndex2) {
//			//TODO: test me!!!!. 
//			MatchMapping m1 = mappings.getAnOptimalMapping(traceIndex, traceIndex1);
//			MatchMapping m2 = mappings.getAnOptimalMapping(traceIndex, traceIndex2);
//			int cost = m1.getCost() - m2.getCost();
//			if (cost != 0) {
//				return cost;
//			}
//			return traceIndex1 - traceIndex2;
//		}
//
//	}
//
//	private void annotateDeviations(RepEGraph regGraph, List<ENode> deviatingNodes, List<EEdge> deviatingEdges,
//			List<DAnnotatedTrace> annotatedTraces) {
//		// Annotated deviating dependencies
//		for (EEdge deviatingEdge : deviatingEdges) {
//			Set<Integer> traces = regGraph.getEdgeRepresentedEdges().get(deviatingEdge.getId()).keySet();
//			Map<Integer, Integer> mapTrace2Source = regGraph.getNodeRepresentedNodes().get(deviatingEdge.getSourceId());
//			Map<Integer, Integer> mapTrace2Target = regGraph.getNodeRepresentedNodes().get(deviatingEdge.getTargetId());
//
//			for (Integer traceIndex : traces) {
//				int eventSourceIndex = mapTrace2Source.get(traceIndex);
//				int eventTargetIndex = mapTrace2Target.get(traceIndex);
//
//				DAnnotatedTrace annotatedTrace = annotatedTraces.get(traceIndex);
//				annotatedTrace.setDependencyDeviating(eventSourceIndex, eventTargetIndex);
//			}
//
//		}
//
//		// Annotated deviating events
//		for (ENode deviatingNode : deviatingNodes) {
//			Map<Integer, Integer> mapTrace2Event = regGraph.getNodeRepresentedNodes().get(deviatingNode.getId());
//			for (Entry<Integer, Integer> entry : mapTrace2Event.entrySet()) {
//				int traceIndex = entry.getKey();
//				int eventIndex = entry.getValue();
//				DAnnotatedTrace annotatedTrace = annotatedTraces.get(traceIndex);
//				annotatedTrace.setEventDeviating(eventIndex);
//			}
//		}
//
//	}
//
//	private void identifyDeviatingNodesAndEdges(RepEGraph regGraph, LogRepairConfiguration conf,
//			List<ENode> deviatingNodes, List<EEdge> deviatingEdges) {
//		// 1.2 classify nodes and edges according to filters... 
//
//		//FIXME: now hard-coded filtering
//		PGraphFilter<ENode> nodefilter = new PGraphFilterLabelAEventFreqSingleGraphImpl(regGraph);
//		for (ENode node : regGraph.getNodes()) {
//
//			// if node infreq, classify
//			if (!nodefilter.isSatisfied(node)) {
//				deviatingNodes.add(node);
//			}
//		}
//		//TODO: add
//		for (EEdge edge : regGraph.getEdges()) {
//			// 
//
//		}
//
//	}
//
//	private List<DAnnotatedTrace> initDeviationAnnotatedTraces(XLog log) {
//		List<DAnnotatedTrace> datraces = new ArrayList<DAnnotatedTrace>();
//		for (int traceId = 0; traceId < log.size(); traceId++) {
//			XTrace t = log.get(traceId);
//			DAnnotatedTrace datrace = new DAnnotatedTrace(traceId, t);
//			datraces.add(datrace);
//		}
//		return datraces;
//	}
//}
