package org.processmining.xlu.matching.config.gui;

import java.awt.GridLayout;

import javax.swing.JComponent;
import javax.swing.JLabel;
import javax.swing.JPanel;
import javax.swing.JSlider;
import javax.swing.event.ChangeEvent;
import javax.swing.event.ChangeListener;

import org.processmining.xlu.matching.plugins.alg.EGMatchConfiguration;
import org.processmining.xlu.matching.plugins.alg.impl.CostStrategyConfiguration;

import com.fluxicon.slickerbox.factory.SlickerDecorator;

public class CostConfigSelectorPanel implements EGMatchConfigDialog, ChangeListener {

	private EGMatchConfiguration conf;
	private CostStrategyConfiguration costConfig;
	private int kNeighbor;
	private JComponent dialog;

	SlickerDecorator decorator = SlickerDecorator.instance();
	
	private JSlider sliderKNeighbor;
	private JSlider sliderMatch;
	private JSlider sliderNoMatch;
	private JSlider sliderStruct;
	private JSlider sliderNoMatchConst;

	public CostConfigSelectorPanel(final EGMatchConfiguration conf) {
		kNeighbor = conf.getDist();
		costConfig = conf.getCostStrategy().getCostConfiguration();
		this.conf = conf;
		createDialog();
	}

	private void createDialog() {
		dialog = new JPanel();
		GridLayout experimentLayout = new GridLayout(0, 2);
		dialog.setLayout(experimentLayout);

		JLabel label = new JLabel("KNeighbor:     ");
		dialog.add(label);		
		sliderKNeighbor = new JSlider(0, 10, kNeighbor);
		sliderKNeighbor.addChangeListener(this);
		dialog.add(sliderKNeighbor);

		label = new JLabel("Weight Match   ");
		dialog.add(label);	
		sliderMatch = new JSlider( 0, 10,
				costConfig.getWeightMatched());
		sliderMatch.addChangeListener(this);
		dialog.add(sliderMatch);

		label = new JLabel("Weight No Match");
		dialog.add(label);	
		sliderNoMatch = new JSlider(0, 10,
				costConfig.getWeightNoMatch());
		sliderNoMatch.addChangeListener(this);
		dialog.add(sliderNoMatch);

		label = new JLabel("Weight Structure");
		dialog.add(label);	
		sliderStruct = new JSlider( 0, 10,
				costConfig.getWeightGlobalStructure());
		sliderStruct.addChangeListener(this);
		dialog.add(sliderStruct);

		label = new JLabel("Cost No Match");
		dialog.add(label);	
		sliderNoMatchConst = new JSlider(0, 10,
				costConfig.getWeightBaseCostForNoMatch());
		sliderNoMatchConst.addChangeListener(this);
		dialog.add(sliderNoMatchConst);
		
		
		this.decorator.decorate(sliderKNeighbor);
		this.decorator.decorate(sliderMatch);
		this.decorator.decorate(sliderNoMatch);
		this.decorator.decorate(sliderStruct);
		this.decorator.decorate(sliderNoMatchConst);
	}

	//	private ProMSliderPanel createProMSlider(String title, int min, int max, int value) {
	//		return new ProMSliderPanel(title, min, max, value);
	//	}

	public JComponent showDialog() {
		if (this.dialog == null) {
			createDialog();
		}
		return dialog;
	}

	public String getTitle() {
		return "K-Neighbor, Cost Configuration";
	}

	public void stateChanged(ChangeEvent e) {
		JSlider source = (JSlider)  e.getSource();
		if (!(source.getValueIsAdjusting())) {
			int w =  ((JSlider) e.getSource()).getValue();

			if (source.equals(this.sliderKNeighbor)) {
				this.conf.setDist(w);
			} else {
				if (source.equals(this.sliderMatch)) {
					this.costConfig.setWeightMatched(w);

				} else if (source.equals(this.sliderNoMatch)) {
					this.costConfig.setWeightNoMatch(w);

				} else if (source.equals(this.sliderStruct)) {
					this.costConfig.setWeightGlobalStructure(w);

				} else if (source.equals(this.sliderNoMatchConst)) {
					this.costConfig.setWeightBaseCostForNoMatch(w);
				} else {
					System.err.println(" No original slider found");
				}
				this.conf.setCostStrategyConfiguration(this.costConfig);

			}

		}
	}

}
