package org.processmining.xlu.matching.config.gui;

import java.awt.Dimension;
import java.awt.GridLayout;
import java.util.List;

import javax.swing.DefaultListModel;
import javax.swing.JComponent;
import javax.swing.JPanel;
import javax.swing.ListSelectionModel;
import javax.swing.event.ListSelectionEvent;
import javax.swing.event.ListSelectionListener;

import org.processmining.framework.util.ui.widgets.ProMList;
import org.processmining.xlu.matching.plugins.alg.EGMatchConfiguration;
import org.processmining.xlu.matching.plugins.alg.MatchingAlg;
import org.processmining.xlu.matching.plugins.alg.impl.MatchingAlgBackTrackingPruningImpl;
import org.processmining.xlu.matching.plugins.alg.impl.MatchingAlgGreedyImp;
import org.processmining.xlu.matching.plugins.alg.impl.MatchingAllAlgBackTrackingBFImpl;

public class EGMatchingAlgSelectorDialog extends EGMatchConfigDialogAbstract{

	private JComponent dialog;
	
	
	public EGMatchingAlgSelectorDialog(final EGMatchConfiguration conf) {
		super(conf);
		createDialog();
	}
	
	private void createDialog() {
		dialog = new JPanel();
		GridLayout experimentLayout = new GridLayout(0, 1);
		dialog.setLayout(experimentLayout);
		
		DefaultListModel<MatchingAlg> listModel = new DefaultListModel<MatchingAlg>();
		
			listModel.addElement(new MatchingAllAlgBackTrackingBFImpl());
			listModel.addElement(new MatchingAlgBackTrackingPruningImpl());
			
			final MatchingAlg defaultMatchingAlg = new MatchingAlgGreedyImp();
			listModel.addElement(defaultMatchingAlg);
			this.getEGMatchConfig().setMatchingAlgorithm(defaultMatchingAlg);
			
		final ProMList<MatchingAlg> list = new ProMList<MatchingAlg>("Select Matching Alg.", listModel);
		list.setSelectionMode(ListSelectionModel.SINGLE_SELECTION);
		list.setSelection(defaultMatchingAlg);

		list.addListSelectionListener(new ListSelectionListener() {
			public void valueChanged(ListSelectionEvent e) {
				List<MatchingAlg> selected = list.getSelectedValuesList();
				if (selected.size() == 1) {
					getEGMatchConfig().setMatchingAlgorithm(selected.get(0));
				} else {
					/*
					 * Nothing selected. Revert to selection of default classifier.
					 */
					list.setSelection(defaultMatchingAlg);
					getEGMatchConfig().setMatchingAlgorithm(defaultMatchingAlg);
				}
				
			}
		});
		list.setPreferredSize(new Dimension(100, 100));
		dialog.add(list);		
		
	}

	public String getTitle() {
		return "Select Matching Algorithm";
	}

	public JComponent showDialog() {
		return dialog;
	}

}
