package org.processmining.xlu.matching.config.gui;

import gnu.trove.map.hash.THashMap;
import gnu.trove.set.hash.THashSet;

import java.awt.BorderLayout;
import java.awt.Component;
import java.awt.Dimension;
import java.awt.GridLayout;
import java.awt.event.ActionEvent;
import java.awt.event.ActionListener;
import java.util.Collection;
import java.util.Map;
import java.util.Map.Entry;

import javax.swing.BoxLayout;
import javax.swing.ButtonGroup;
import javax.swing.JComponent;
import javax.swing.JPanel;
import javax.swing.JRadioButton;

import org.processmining.models.jgraph.ProMJGraph;
import org.processmining.models.jgraph.visualization.ProMJGraphPanel;
import org.processmining.partialorder.models.graph.PartialOrderGraph;
import org.processmining.partialorder.util.VisUtil;
import org.processmining.xlu.matching.models.RepEGraph;
import org.processmining.xlu.matching.plugins.alg.impl.CostStrategyConfiguration;

public class MappingSelectorDialog implements EGMatchConfigDialog, ActionListener {
	private JPanel dialog;
	private Map<JRadioButton, RepEGraph> mapButton2Graph;
	private RepEGraph selectedGraph;

	public MappingSelectorDialog(int traceI, int traceJ, Map<PartialOrderGraph, RepEGraph> views,
			Map<CostStrategyConfiguration, Integer> costConfigs) {
		dialog = new JPanel();
		GridLayout experimentLayout = new GridLayout(0, 1);
		dialog.setLayout(experimentLayout);
		dialog.setAlignmentX(Component.LEFT_ALIGNMENT);
		//		dialog = getJGraphScrollPane(mappingsBetweenGraphs.get(0));

		mapButton2Graph = new THashMap<>();
		ButtonGroup group = new ButtonGroup();

		for (Entry<PartialOrderGraph, RepEGraph> view : views.entrySet()) {
			PartialOrderGraph graph = view.getKey();
			ProMJGraph comp = VisUtil.getProMSimpleJGraph(graph, VisUtil.LightBackgroundColor);

		
			JRadioButton button = new JRadioButton();
			mapButton2Graph.put(button, view.getValue());
			button.addActionListener(this);
			group.add(button);
			
			
			JPanel panel = new JPanel();
			panel.setLayout(new BoxLayout(panel, BoxLayout.Y_AXIS));
			panel.setLayout(new BorderLayout());	
//			panel.setLayout(new FlowLayout());
			panel.add(button, BorderLayout.WEST);
			panel.add(getJGraphScrollPane(comp), BorderLayout.CENTER);
			panel.setAlignmentX(Component.LEFT_ALIGNMENT);
			dialog.add(panel);
			//			dialog.add(comp);
			//			dialog.add(getJGraphScrollPane(comp));
		}
		
		
		JRadioButton button = new JRadioButton("None of above");
		dialog.add(button);


	}

	private static JComponent getJGraphScrollPane(ProMJGraph comp) {
				ProMJGraphPanel panel = new ProMJGraphPanel(comp);
						panel.setSize(new Dimension(800,400));
//				panel.addViewInteractionPanel(new ZoomInteractionPanel(panel, ScalableViewPanel.MAX_ZOOM),
//						SwingConstants.WEST);
				panel.scaleToFit();
		//		
		return comp;
	}

	public String getTitle() {
		return "Mapping Selector";
	}

	public JComponent showDialog() {
		return dialog;
	}

	public void actionPerformed(ActionEvent e) {
		JRadioButton source = (JRadioButton) e.getSource();

		if (source.isSelected()) {
			RepEGraph g = mapButton2Graph.get(source);
			if (g != null) {
				selectedGraph = g;
			} else {
				selectedGraph = null;
			}
		}
	}

	//	}

	

	public RepEGraph getSelectedRepEGraph() {
		return this.selectedGraph;
	}
	
	public Collection<RepEGraph> getNotSelectedRepEGraphs(){
		Collection<RepEGraph> res =  new THashSet<>(mapButton2Graph.values());
		res.remove(this.selectedGraph);
		return res;
	}

}
