package org.processmining.xlu.matching.config.gui;

import java.awt.Dimension;
import java.awt.GridLayout;
import java.util.List;

import javax.swing.DefaultListModel;
import javax.swing.JComponent;
import javax.swing.JPanel;
import javax.swing.ListSelectionModel;
import javax.swing.event.ListSelectionEvent;
import javax.swing.event.ListSelectionListener;

import org.deckfour.xes.classification.XEventClassifier;
import org.deckfour.xes.model.XLog;
import org.processmining.framework.util.ui.widgets.ProMList;
import org.processmining.xlu.matching.plugins.alg.EGMatchConfiguration;

public class XEventClassSelectorPanel extends EGMatchConfigDialogAbstract{
	
	
	private JComponent dialog;
	private XLog log;
	
	public XEventClassSelectorPanel(final EGMatchConfiguration config, XLog log){
		super(config);
		this.log = log;
		createDialog(log.getClassifiers());		
	}
	
	private void createDialog(List<XEventClassifier> classifiers) {
		dialog = new JPanel();
		GridLayout experimentLayout = new GridLayout(0, 1);
		dialog.setLayout(experimentLayout);
		
		final XEventClassifier defaultClassifier = getEGMatchConfig().getClassifier();
		
		DefaultListModel<XEventClassifier> listModel = new DefaultListModel<XEventClassifier>();
		listModel.addElement(defaultClassifier);
		for (XEventClassifier classifier: classifiers) {
			listModel.addElement(classifier);
		}		
		
		final ProMList<XEventClassifier> list = new ProMList<XEventClassifier>("Select classifier", listModel);
		list.setSelectionMode(ListSelectionModel.SINGLE_SELECTION);
		
		list.setSelection(defaultClassifier);

		list.addListSelectionListener(new ListSelectionListener() {
			public void valueChanged(ListSelectionEvent e) {
				List<XEventClassifier> selected = list.getSelectedValuesList();
				if (selected.size() == 1) {
					getEGMatchConfig().setClassifier(selected.get(0));
				} else {
					/*
					 * Nothing selected. Revert to selection of default classifier.
					 */
					list.setSelection(defaultClassifier);
					getEGMatchConfig().setClassifier(defaultClassifier);
				}				
			}
		});
		list.setPreferredSize(new Dimension(100, 100));
		dialog.add(list);		
	}

	public static List<XEventClassifier> getClassifiers(XLog log){
		return log.getClassifiers();
	}
	
	public String getTitle(){
		return "Event Classifier";
	}
	
	public JComponent showDialog(){
		return dialog;
	}
	

}
