package org.processmining.xlu.matching.merge.impl;

import org.deckfour.xes.model.XLog;
import org.processmining.xlu.matching.models.ENode;
import org.processmining.xlu.matching.models.RepEGraph;
import org.processmining.xlu.pgraph.vis.filter.PGraphFilter;
import org.processmining.xlu.pgraph.vis.filter.PGraphFilterEventFreqSingleGraphImpl;

public class FusionStrategyIncrFilteringImpl extends FusionStrategyIncrBinaryImpl {
	//	private PGraphFilter<ENode> eventFilter;

	public FusionStrategyIncrFilteringImpl(XLog log) {
		super(null, log);
	}

	// Keeping this filter is useless. To use different filters (not hard coded), you need to create FilterFactory. 
	// Then you can set the factory, and in areValidMatch, use the instance of factory to create different event filters...
	//	public void setFilter(PGraphFilter<ENode> eventFilter) {
	//		this.eventFilter = eventFilter;
	//	}
	//
	//	public PGraphFilter<ENode> getFilter() {
	//		return this.eventFilter;
	//	}

	@Override
	protected boolean areValidMatch(ENode sourceInSourceREG, RepEGraph sourceREG, ENode targetInTargetREG,
			RepEGraph targetREG) {
		PGraphFilter<ENode> eventSourceFilter = new PGraphFilterEventFreqSingleGraphImpl(sourceREG);
		PGraphFilter<ENode> eventTargetFilter = new PGraphFilterEventFreqSingleGraphImpl(targetREG);
		return (eventSourceFilter.isSatisfied(sourceInSourceREG) && eventTargetFilter.isSatisfied(targetInTargetREG));
	}

}
