package org.processmining.xlu.matching.models;

import java.util.List;

/**
 * The interface of execution graphs. 
 * 
 * 
 * @author xlu
 *
 */

public interface EGraph  {
	
	public int addNode(ENode node);
	public void removeNode(ENode node);
	public List<ENode> getNodes();	
	public ENode getNodeById(int id);
	public List<ENode> getNodesWithLabel(ENode sourceNode);
	
	
	public int addEdge(EEdge edge);
	public List<EEdge> getEdges();	
	public EEdge getEdge(int newSourceId, int newTargetId);

	
	
	public int getSize();
	public int getId();
	public void setId(int id);

	
	public int getDist(int sourceId, int targetId);
}


//public interface EGraph<T, P, NT, NP, ET, EP> extends EAttributable<T, P> {
//	
//	public int addNode(ENode<NT, NP> node);
//	public List<ENode<NT, NP>> getNodes();	
//	public ENode<NT, NP> getNode(int index);
//	public List<ENode<NT, NP>> getNodesWithLabel(ENode<NT, NP> sourceNode);
//	
//	
//	public int addEdge(EEdge<ET, EP> edge);
//	public List<EEdge<ET, EP>> getEdges();	
//	public int getSize();
//
//	
//
//
//
//}
