package org.processmining.xlu.matching.models;

import java.util.Map;
import java.util.Map.Entry;
import java.util.Set;

public interface MatchMapping  {
	
	/**
	 * This function add a mapping between the sourceNode and the targetNode. 
	 * If one of them is null, the other is considered to be mapped to null element. 
	 * @param sourceNode
	 * @param targetNode
	 */
	public void addMatch(ENode sourceNode, ENode targetNode);
	
	/**
	 * This function returns the id of source node that is mapped to the input targetNodeId.
	 * If targetNodeId is mapped to null element, the function returns null.
	 * @param targetNodeId
	 * @return
	 */	
	public Integer getSourceNodeIdMappedTo(int targetNodeId);
	
	public Integer getTargetNodeIdMappedTo(int sourceNodeId);
	
	/* TODO: refactor old */
	
//	public Collection<Integer> getRang();
	
//	public void addMatchByIds(int newId, int targetNodeId);
	
	public void removeMatch(ENode source, ENode target);

//	public MatchMapping clone();

	public Set<Entry<Integer, Integer>> getMatchs();
	public Map<Integer, Integer> getMap();
	public Set<Integer> getSourcesToNull();
	public Set<Integer> getTargetToNull();


	public void clone(MatchMapping mapping);
	
	/* TODO: should not be here? */
	public int getCost();
	public void setCost(int cost);
	
	public void setSourceGraph(EGraph graph);
	public void setTargetGraph(EGraph graph);
	public EGraph getSourceGraph();
	public EGraph getTargetGraph();

	public void inverse();

	public boolean inDomain(int sourceNodeId);
	public boolean inRange(int targetNodeId);

	
}
