package org.processmining.xlu.matching.models;

import java.util.List;
import java.util.Map;


public interface RepEGraph extends EGraph {

	public void addRepresentedGraph(int graphId);

	public void updateNodeRepresentedNode(int nodeId, int orgGraphId, int orgNodeId);

	public void updateEdgeRepresentedEdge(int edgeId, int orgGraphId, int orgEdgeId);
	
	public ENode getNodeRepresenting(int graphId, int nodeId);
	
	
	public List<Integer> getRepresentedGraphIds();

	public Map<Integer, Map<Integer, Integer>> getEdgeRepresentedEdges();
	
	public Map<Integer, Map<Integer, Integer>> getNodeRepresentedNodes();
	
	
	
	//TODO : these are ad-hoc properties implementation. To be generalized. 
	public int getCost();
	public void setCost(int cost);
	
	public Map<String, Integer> getCosts();
	public int getCost(String costFunctionName);
	public void setCost(String costFunctionName, int cost);
	
	public Map<Integer, Integer> getNodeToCost();
	public void setNodeToCost( Map<Integer, Integer> nodeToCost);
	public Map<Integer, Boolean> getNodeToMappedCorrectly();
	public void setNodeToCorrect( Map<Integer, Boolean> nodeToCorrect);

	

}
