package org.processmining.xlu.matching.models.impl;

import java.util.HashMap;
import java.util.Map;

import org.processmining.xlu.matching.models.EGraph;
import org.processmining.xlu.matching.models.ENode;

public abstract class ENodeAbstract implements ENode {

	protected int nodeId; // currently is event index. 
	protected int graphId; // currently is trace index. 
	//	protected EGraph graph;
	protected String label;

	protected Map<String, Object> properties;
	

	public ENodeAbstract(EGraph eg, String label) {
		//		this.graph = graph;
		this.label = label;
		this.properties = new HashMap<String, Object>();
	}

	public int getIndex() {
		return nodeId;
	}

	public String getLabel() {
		return label;
	}

	public int getId() {
		return nodeId;
	}

	public void setId(Integer newId) {
		this.nodeId = newId;
	}

	public int getGraphId() {
		return graphId;
	}

	public void setGraphId(int id) {
		this.graphId = id;
	}

	public Object getProperty(String key) {
		return this.properties.get(key);
	}

	public void setProperty(String key, Object value) {
		this.properties.put(key, value);
	}
	
	public String toString(){
		return label;
	}

	//
	//	public EGraph getGraph() {
	//		return this.graph;
	//	}

}
