package org.processmining.xlu.matching.models.impl;

import java.util.ArrayList;
import java.util.List;

import org.processmining.xlu.matching.models.EGraph;
import org.processmining.xlu.matching.models.ENode;

public class ENodeAwareImpl extends ENodeAbstract implements ENode {
	
	List<Integer> predIds = new ArrayList<>(); 
	List<Integer> succIds= new ArrayList<>();
	List<Integer> concIds= new ArrayList<>();
	
	
	int[] preds = new int[0];
	int[] succs = new int[0];
	int[] concs = new int[0];

	public ENodeAwareImpl(EGraph graph, String label) {
		super(graph, label);
	}
	
	public ENodeAwareImpl(EGraph graph, String label, List<Integer> preds, List<Integer> succs, List<Integer> concs) {
		this(graph, label);
		this.predIds = preds;
		this.succIds = succs;
		this.concIds = concs;
	}
	
	

	public ENodeAwareImpl(EGraph eg, String label, List<Integer> predIds, List<Integer> succIds,
			List<Integer> concIds, int[] preds, int[] succs, int[] concs) {
		this(eg, label, predIds, succIds, concIds);
		this.preds = preds;
		this.concs = concs;
		this.succs = succs;
	}

	public boolean isVisible() {
		return true;
	}

	public List<Integer> getPredIds() {
		return this.predIds;
	}

	public List<Integer> getSuccIds() {
		return this.succIds;
	}

	public List<Integer> getConcIds() {
		return this.concIds;
	}
		
//	public int getInDegree() {
//		// TODO Auto-generated method stub
//		return 0;
//	}
//
//	public int getOutDegree() {
//		// TODO Auto-generated method stub
//		return 0;
//	}
//	
	public int[] getPreds() {
		return this.preds;
	}

	public int[] getSuccs() {
		return this.succs;
	}

	public int[] getConcs() {
		return this.concs;
	}

}
