package org.processmining.xlu.matching.plugins.alg;

import org.processmining.xlu.matching.models.EGraph;
import org.processmining.xlu.matching.models.MatchMapping;
import org.processmining.xlu.matching.plugins.alg.impl.CostStrategyConfiguration;


public interface CostStrategy {

	/**
	 * Main cost function. 
	 * @param source	The nodes of the source graph are the domain of the mapping
	 * @param target	The nodes of the target graph are the range of the mapping
	 * @param mapping	The COMPLETE mapping between between the nodes of the two graphs 
	 * @return
	 */
	int getTotalCost(EGraph source, EGraph target, MatchMapping mapping);
	
//	int getCost(ENode source, ENode target, MatchMapping mapping);
//	int getCostNoMapping(ENode n, MatchMapping mapping);

//	int getCost(ENode source, ENode target);
//	int getCostNoMapping(ENode n);
	
	
	public void setCostConfiguration(CostStrategyConfiguration config);
	public CostStrategyConfiguration getCostConfiguration();

	public abstract int getWeightedCostOfGlobalStructure(Integer source, Integer target, MatchMapping mapping);

	public abstract int getWeightedCostNoMatch(Integer nodeId, EGraph NodeGraph, MatchMapping mapping);

	public abstract int getWeightedCostofMatchedPair(Integer sourceId, Integer targetId,
			MatchMapping mapping);
	

}
