package org.processmining.xlu.matching.plugins.alg;

import java.util.Set;

import org.deckfour.xes.classification.XEventClasses;
import org.deckfour.xes.classification.XEventClassifier;
import org.processmining.partialorder.ptrace.param.PTraceParameter;
import org.processmining.xlu.matching.plugins.alg.impl.CostStrategyConfiguration;
import org.processmining.xlu.matching.preprocessing.PTraceToEGConverter;

public interface EGMatchConfiguration {
	

	public XEventClasses getClasses();
	public XEventClassifier getClassifier();
	
	public void setClasses(XEventClasses classes);
	public void setClassifier(XEventClassifier classifier);
	
	public PTraceToEGConverter getConverter();
	public void setConverter(PTraceToEGConverter converter);
	
	public MatchingAlg getMatchingAlgorithm();
	public CostStrategy getCostStrategy();
	
	public void setMatchingAlgorithm(MatchingAlg alg);
	public void setCostStrategy(CostStrategy costfunction);
	public void setCostStrategyConfiguration(CostStrategyConfiguration costStrategyConfiguration);
	
	public int getDist();
	public void setDist(int dist);
	public void setQualityOpt(boolean b);
	public boolean isQualityOpt();
	public PTraceParameter getPTraceParameter();
	public void setPTraceParameter(PTraceParameter pTraceParameter);
	
	
	public void setFocusOnMatchingLabels(Set<String> labels);
	public Set<String> getLabels();
	
}
