package org.processmining.xlu.matching.plugins.alg;

import java.util.Comparator;

import org.processmining.xlu.matching.models.ENode;
import org.processmining.xlu.matching.models.impl.ENodeProperties;

public class ENodeContextAndLabelComparator implements Comparator<ENode> {

	/*
	 * {(x, y) such that c.compare(x, y) <= 0}.
	 */
	public int compare(ENode s, ENode t) {
		Double sContextFreq = (Double) s.getProperty(ENodeProperties.KEY_CONTEXTFREQ_PROP);
		Double tContextFreq = (Double) t.getProperty(ENodeProperties.KEY_CONTEXTFREQ_PROP);
		
		Double sLabelFreq = (Double) s.getProperty(ENodeProperties.KEY_LABELFREQ_PROP);
		Double tLabelFreq = (Double) t.getProperty(ENodeProperties.KEY_LABELFREQ_PROP);

		if (sContextFreq != null && tContextFreq != null && 
				sLabelFreq != null && tLabelFreq != null
				) {
			// sContextFreq > tContextFreq => (s, t)
			if(tContextFreq + tLabelFreq > sContextFreq + sLabelFreq){
				return 1;
			} else if (tContextFreq + tLabelFreq < sContextFreq + sLabelFreq){
				return -1;
			} else {
				
				if(sContextFreq != tContextFreq){
					return tContextFreq > sContextFreq? 1 : -1;
				} else if (sLabelFreq != tLabelFreq){
					return tLabelFreq > sContextFreq ? 1 : -1;
				}				
			}
//			return tContextFreq - sContextFreq;
		}

		if (s.getId() != t.getId()) {
			// s.id < t.id => (s,t)
			return s.getId() - t.getId();
		}

		return s.getGraphId() - t.getGraphId();
	}



}
