package org.processmining.xlu.matching.plugins.alg;

import java.util.Comparator;

import org.processmining.xlu.matching.models.ENode;
import org.processmining.xlu.matching.models.impl.ENodeProperties;

public class ENodeContextComparator implements Comparator<ENode> {

	/*
	 * {(x, y) such that c.compare(x, y) <= 0}.
	 */
	public int compare(ENode s, ENode t) {
		Integer sContextFreq = (Integer) s.getProperty(ENodeProperties.KEY_CONTEXTFREQ);
		Integer tContextFreq = (Integer) t.getProperty(ENodeProperties.KEY_CONTEXTFREQ);

		if (sContextFreq != null && tContextFreq != null && sContextFreq != tContextFreq) {
			// sContextFreq > tContextFreq => (s, t)
			return tContextFreq - sContextFreq;
		}

		if (s.getId() != t.getId()) {
			// s.id < t.id => (s,t)
			return s.getId() - t.getId();
		}

		return s.getGraphId() - t.getGraphId();
	}

}
