package org.processmining.xlu.matching.plugins.alg.impl;

import java.util.ArrayList;
import java.util.List;

import org.processmining.xlu.matching.models.ENode;
import org.processmining.xlu.matching.models.MatchMapping;

public class CostFunctionImpl extends CostStrategyAbstract {
	
	public String toString(){
		return "CostFunctionImpl";
	}

	@Override
	public int getCost(ENode source, ENode target, MatchMapping mapping) {
		int sumCost = 0;

//		// TODO node properties...
//		int costNodeProperties = 0;
//		for (Entry<String, Integer> entry : csConfig.getPropertyWeights().entrySet()) {
//			int weight = entry.getValue();
//			String key = entry.getKey();
//			int c = source.getProperty(key) == target.getProperty(key) ? 0 : 1;
//			costNodeProperties += weight * c;
//		}
//		sumCost += costNodeProperties;

		// Node neighbors. 
		int costNodeNeighbors = 0;
		List<Integer> targetPreds = new ArrayList<Integer>(target.getPredIds());
		List<Integer> targetSuccs = new ArrayList<Integer>(target.getSuccIds());
		List<Integer> targetConcs = new ArrayList<Integer>(target.getConcIds());

		costNodeNeighbors +=  getCost(source, target, source.getPredIds(), targetPreds, mapping);
		costNodeNeighbors +=  getCost(source, target, source.getSuccIds(), targetSuccs, mapping);
		costNodeNeighbors +=  getCost(source, target, source.getConcIds(), targetConcs, mapping);

		sumCost += costNodeNeighbors;
		return sumCost;
	}

	static int getCost(ENode source, ENode target, List<Integer> sourceContext, List<Integer> targetContext,
			MatchMapping mapping) {
		int sumCost = 0;
		for (Integer sourceNeighbor : sourceContext) {
			Integer targetPred = mapping.getTargetNodeIdMappedTo(sourceNeighbor);
			if (targetPred == null || !targetContext.remove(targetPred)) {
				// a neighbor of source is mapped to nothing or to a node not in the neighbor of target
				sumCost += 1;
			}
		}
		for (Integer i : targetContext) { // neighbors of target either mapped to nothing or to a node not in the neighbor of source
			//ENode targetNeighborNode = mapping.getTargetGraph().getNode(i);
			sumCost += 1;
		}
		return sumCost;
	}

	//	private int getCost(EEdge sourceEdge, EEdge targetEdge) {
	//		// TODO Auto-generated method stub
	//		return 0;
	//	}

	@Override
	public int getCostNoMatch(ENode n, MatchMapping mapping) {
		int sumCost = this.csConfig.getWeightBaseCostForNoMatch();
		sumCost += n.getPredIds().size();
		sumCost += n.getSuccIds().size();
		sumCost += n.getConcIds().size();
		return sumCost;
	}
}
