package org.processmining.xlu.matching.plugins.alg.impl;

import java.util.ArrayList;
import java.util.List;

import org.processmining.xlu.matching.models.ENode;
import org.processmining.xlu.matching.models.MatchMapping;

public class CostFunctionNeighborAsMultisetImpl extends CostStrategyAbstract {

	public String toString(){
		return "Cost Function with Neighbor Exchangable";
	}
	
	protected int getCost(ENode source, ENode target, MatchMapping mapping) {
		int sumCost = 0;
		List<Integer> targetNeighbors = new ArrayList<Integer>();
		targetNeighbors.addAll(target.getPredIds());
		targetNeighbors.addAll(target.getSuccIds());
		targetNeighbors.addAll(target.getConcIds());
		
		
		List<Integer> sourceNeighbors = new ArrayList<Integer>();
		sourceNeighbors.addAll(source.getPredIds());
		sourceNeighbors.addAll(source.getSuccIds());
		sourceNeighbors.addAll(source.getConcIds());
		
		sumCost = CostFunctionImpl.getCost(source, target, sourceNeighbors, targetNeighbors, mapping);
		return sumCost;
	}

	@Override
	public int getCostNoMatch(ENode n, MatchMapping mapping) {
		int sumCost = this.csConfig.getWeightBaseCostForNoMatch();
		sumCost += n.getPredIds().size();
		sumCost += n.getSuccIds().size();
		sumCost += n.getConcIds().size();
		return sumCost;
	}

}
