package org.processmining.xlu.matching.plugins.alg.impl;

import org.processmining.xlu.matching.models.ENode;
import org.processmining.xlu.matching.models.MatchMapping;
import org.processmining.xlu.matching.plugins.alg.HeuristicStrategy;

/**
 * This class implements a cost function that is independent of the mapped nodes
 * given by the mapping.
 * 
 * @author xlu
 * 
 */
public class CostHeuristicFunctionSimpleImpl extends CostStrategyAbstract implements HeuristicStrategy  {

	
	public String toString(){
		return "CostHeuristicFunctionSimple";
	}
	
	public int getCost(ENode source, ENode target) {
		int sumCost = 0;
//		int sumTot = 0;
		int length = source.getPreds().length;
//		int alpha = 1;

		for (int i = 0; i < length; i++) {
			sumCost += Math.abs(source.getPreds()[i] - target.getPreds()[i]);
			sumCost += Math.abs(source.getSuccs()[i] - target.getSuccs()[i]);
			sumCost += Math.abs(source.getConcs()[i] - target.getConcs()[i]);

//			sumTot += source.getPreds()[i] + target.getPreds()[i];
//			sumTot += source.getSuccs()[i] + target.getSuccs()[i];
//			sumTot += source.getConcs()[i] + target.getConcs()[i];
		}
		return sumCost;
	}
	
	public int getCostNoMapping(ENode n) { 
		int sumCost = this.csConfig.getWeightBaseCostForNoMatch();
		sumCost += n.getPredIds().size();
		sumCost += n.getSuccIds().size();
		sumCost += n.getConcIds().size();
		return sumCost;
	}

	public int getCost(ENode source, ENode target, MatchMapping mapping) {
		return getCost(source, target);
	}

	public int getCostNoMatch(ENode n, MatchMapping mapping) {
		return getCostNoMapping(n);
	}

}
