package org.processmining.xlu.matching.plugins.alg.impl;

import java.util.ArrayList;
import java.util.List;

import org.processmining.xlu.matching.models.EGraph;
import org.processmining.xlu.matching.models.ENode;
import org.processmining.xlu.matching.models.MatchMapping;
import org.processmining.xlu.matching.models.impl.MatchMappingImpl;

/**
 * 
 * Algorithm 3: Decomposed and heuristic pruning. No optimal 
 * Future... TODO?!!!! Not working now. 
 * 
 * @author xlu
 *
 */
public class MatchingAlgDecomposedBackTrackingImpl extends MatchingAlgBackTrackingPruningImpl {

	/**
	 * TODO 
	 */
	@Override
	public MatchMapping getOptimalMapping(EGraph g1, EGraph g2) {
		MatchMapping mapping = new MatchMappingImpl(g1, g2);
		MatchMapping optMapping = new MatchMappingImpl(g1, g2);

		List<ENode> sources = new ArrayList<ENode>(g1.getNodes());
		List<ENode> targets = new ArrayList<ENode>(g2.getNodes());

		//Match start and end remove from choices. 
		matchDummyStartEndAndUpdateMapping(sources, targets, mapping);

		int costSoFar = 0;
		int minCost = Integer.MAX_VALUE;
		while (!sources.isEmpty() || !targets.isEmpty()) {
			List<ENode> dependentSources = new ArrayList<>();
			List<ENode> dependentTargets = new ArrayList<>();
			
			getSubSourcesAndTargetsForRecurseAndRemoveFromOrginalSourcesAndTarget(sources, targets, dependentSources, dependentTargets);
			
//			minCost = recursePruning(dependentSources, dependentTargets, mapping, 0, optMapping, Integer.MAX_VALUE);
			mapping.clone(optMapping);
			costSoFar += minCost;
		}

		int cost = this.getCostStrategy().getTotalCost(optMapping.getSourceGraph(), optMapping.getTargetGraph(), optMapping);
		// TODO: check cost > costSoFar. 
		optMapping.setCost(cost);

		return optMapping;
	}

	private void getSubSourcesAndTargetsForRecurseAndRemoveFromOrginalSourcesAndTarget(List<ENode> sources, List<ENode> targets, List<ENode> dependentSources, List<ENode> dependentTargets) {
		if (!sources.isEmpty() && !targets.isEmpty()) {
			ENode snode = sources.get(0);
			dependentSources = getNodesWithSameLabelAndRemoveFrom(sources, snode);
			dependentTargets = getNodesWithSameLabelAndRemoveFrom(targets, snode);
		} else {
			dependentSources.addAll(sources);
			sources.clear();
			dependentTargets.addAll(targets);
			targets.clear();
		}
	}

	private List<ENode> getNodesWithSameLabelAndRemoveFrom(List<ENode> sources, ENode snode) {
		List<ENode> res = new ArrayList<ENode>();
		for (ENode e : sources) {
			if (e.getLabel().equals(snode.getLabel())) {
				res.add(e);
			}
		}
		sources.removeAll(res);
		return res;
	}
}
