package org.processmining.xlu.matching.vis;

import java.awt.Dimension;
import java.util.ArrayList;
import java.util.List;

import javax.swing.SwingConstants;

import org.processmining.models.graphbased.AttributeMap;
import org.processmining.models.shapes.RoundedRect;
import org.processmining.partialorder.models.graph.PONode;
import org.processmining.partialorder.models.graph.PartialOrderGraph;
import org.processmining.partialorder.plugins.vis.PGraphColorStyle;
import org.processmining.xlu.matching.models.ENode;

public class POMatchNode extends PONode {
	String label;
	int size;
	private ENode objectNode;
	
	private int labelFontSize = 4;

	public POMatchNode(PartialOrderGraph graph, String label, ENode n) {
		super(graph);
		this.label = label;
		this.size = 50;
		this.objectNode = n;
		initAttributeMap();
	}

	protected void initAttributeMap() {
		String html = getHTMLLabel();
		getAttributeMap().put(AttributeMap.LABEL, html);

		getAttributeMap().put(AttributeMap.LABELHORIZONTALALIGNMENT, SwingConstants.CENTER);
		getAttributeMap().put(AttributeMap.LABELVERTICALALIGNMENT, SwingConstants.CENTER);
		
		getAttributeMap().put(AttributeMap.BORDERWIDTH, 2);
		getAttributeMap().put(AttributeMap.SHAPE, new RoundedRect());
		getAttributeMap().put(AttributeMap.SIZE, new Dimension(50 , 30));
		getAttributeMap().put(AttributeMap.FILLCOLOR, PGraphColorStyle.EVENT_NODE_COLOR);
	}

	private String getHTMLLabel() {
		String html = "<!DOCTYPE html><html><body>"
				+ "<p><font size=\""+labelFontSize +"\">" + label + "</font></p></body></html>";
		return html;
	}
	

	
	public void setFontSize(int fontsize){
		this.labelFontSize = fontsize;
		String html = getHTMLLabel();
		getAttributeMap().put(AttributeMap.LABEL, html);
	}

	public String toStringType() {
		return "Match Node";
	}

	public Object[][] getInfo() {
		// TODO Auto-generated method stub
		List<Object[]> infoSingleNode = new ArrayList<Object[]>();
		infoSingleNode.add( new Object[]{"Match", "Todo"});
		return infoSingleNode.toArray(new Object[0][]);
	}

}
