package org.processmining.xlu.matching.zexperiment;

import java.awt.Image;

import org.processmining.partialorder.ptrace.param.PTraceParameter.PTraceType;
import org.processmining.xlu.matching.plugins.alg.EGMatchConfiguration;
import org.processmining.xlu.matching.zexperiment.model.FusionBinaryResult;

public class EGMatchExpPrintResultUtil {

	public static String[] printColumnNames() {
		String[] record = new String[] { 
				"NumNois", "NumRepeat",
				"PTraceType", "KNeighbors", //TODO concurrent true or false
				"CostFunction", "CostFunctionConfig",

				"WMatched", "WNoMatch", "WGlobal", "WBaseCostNoMatch",

				"MatchingAlg", "QualityOpt", "TP", "FP",
				"Time Comp. EG", "Time Comp. Mappings", "Time Binary Fusion", "Time Inc. Fusion"};
		
		
		return record;
	}

	/**
	 * Returns an Image object that can then be painted on the screen. 
	 * The url argument must specify an absolute {@link URL}. The name
	 * argument is a specifier that is relative to the url argument. 
	 * <p>
	 * This method always returns immediately, whether or not the 
	 * image exists. When this applet attempts to draw the image on
	 * the screen, the data will be loaded. The graphics primitives 
	 * that draw the image will incrementally paint on the screen. 
	 *
	 * @param  url  an absolute URL giving the base location of the image
	 * @param  name the location of the image, relative to the url argument
	 * @return      the image at the specified URL
	 * @see         Image
	 */
	public static String[] printResult(PTraceType type, EGMatchConfiguration conf,
			FusionBinaryResult data, RunningTimes times, int numRepeat, int numNoise) {
		String[] record = new String[18];
		int i = 0;
		
		record[i++] = String.valueOf(numNoise);
		record[i++] = String.valueOf(numRepeat);
		record[i++] = type.toString();
		record[i++] = String.valueOf(conf.getDist());
		record[i++] = conf.getCostStrategy().toString();
		record[i++] = conf.getCostStrategy().getCostConfiguration().getName();

		record[i++] = String.valueOf(conf.getCostStrategy().getCostConfiguration().getWeightMatched());
		record[i++] = String.valueOf(conf.getCostStrategy().getCostConfiguration().getWeightNoMatch());
		record[i++] = String.valueOf(conf.getCostStrategy().getCostConfiguration().getWeightGlobalStructure());
		record[i++] = String.valueOf(conf.getCostStrategy().getCostConfiguration().getWeightBaseCostForNoMatch());

		record[i++] = conf.getMatchingAlgorithm().toString();
		record[i++] = String.valueOf(conf.isQualityOpt());
		record[i++] = String.valueOf(data.truePositive);
		record[i++] = String.valueOf(data.falsePositive);
		
		record[i++] = String.valueOf(times.computingEGtime);
		record[i++] = String.valueOf(times.computingMappingTime);
		record[i++] = String.valueOf(times.computingBinaryFusion);
		record[i++] = String.valueOf(times.computingIncFusion);

		return record;
	}
}
