package org.processmining.xlu.matching.zexperiment;

import java.io.File;
import java.io.FileWriter;
import java.io.IOException;
import java.io.Writer;
import java.util.HashMap;
import java.util.Map;

import com.csvreader.CsvWriter;


public class EGMatchExpResultsWriters  {

	private Map<String, CsvWriter> writers = new HashMap<>();
	private String directory;
	
	private String matchResFile;
	private String fusionResFile;
	private String filterResFile; 
	
	
	public EGMatchExpResultsWriters(String dir, String matchResFile, String fusionResFile, String filterResFile){	
		this.directory = dir;
		this.matchResFile = matchResFile;
		createWriter(matchResFile);
		this.fusionResFile = fusionResFile;
		createWriter(fusionResFile);
		this.filterResFile = filterResFile;
		createWriter(filterResFile);
	}
	
	public CsvWriter getMatchResWriter(){
		return writers.get(this.matchResFile);
	}
	public CsvWriter getFusionresWriter(){
		return writers.get(this.fusionResFile);
	}
	public CsvWriter getFilterResWriter(){
		return writers.get(this.filterResFile);
	}
	
//	private CsvWriter getWriter(String file) {
//		CsvWriter writer = writers.get(file);
//		if(writer == null){
//			 writer = createWriter(file);
//		}
//		return writer;
//	}

	public CsvWriter createWriter(String file) {
		String fileName = directory +  file + ".csv";
		Writer fileFusionWriter = null;
		try {
			fileFusionWriter = new FileWriter(new File(fileName));
		} catch (IOException e) {
			e.printStackTrace();
		}
		CsvWriter csvFusionWriter = new CsvWriter(fileFusionWriter, ';');
		
		this.writers.put(file, csvFusionWriter);
		return csvFusionWriter;
	}

	public void closeAllWriters() {
		for(  CsvWriter w : this.writers.values()){
			w.close();
		}
	}



}
