package org.processmining.xlu.matching.zexperiment;

import java.util.Map;
import java.util.Map.Entry;

import org.deckfour.xes.classification.XEventClass;
import org.deckfour.xes.classification.XEventClasses;
import org.processmining.models.graphbased.directed.petrinet.elements.Transition;
import org.processmining.models.semantics.petrinet.Marking;
import org.processmining.plugins.connectionfactories.logpetrinet.TransEvClassMapping;
import org.processmining.plugins.petrinet.replayer.algorithms.costbasedcomplete.CostBasedCompleteParam;

public class ExprReplayUtils {

	/**
	 * 
	 * @param initM
	 * @param finalM
	 * @param newClasses
	 * @param etMapping
	 * @param logMoveCost
	 * @param modelMoveCost
	 * @return
	 */
	public static CostBasedCompleteParam getCostBasedCompleteParam(Marking initM, Marking finalM,
			XEventClasses newClasses, TransEvClassMapping etMapping, int logMoveCost, int modelMoveCost) {
		CostBasedCompleteParam replayParam = new CostBasedCompleteParam(etMapping.values(),
				etMapping.getDummyEventClass(), etMapping.keySet());

		Map<XEventClass, Integer> map = replayParam.getMapEvClass2Cost();
		for (XEventClass c : newClasses.getClasses()) {
			//			Integer cost = map.get(c);
			map.put(c, logMoveCost);
		}
		for (Entry<Transition, Integer> t : replayParam.getMapTrans2Cost().entrySet()) {
			replayParam.getMapTrans2Cost().put(t.getKey(), t.getValue() > 0 ? modelMoveCost : 0);
		}
		replayParam.setInitialMarking(initM);
		replayParam.setFinalMarkings(finalM);
		return replayParam;
	}

}
