package org.processmining.xlu.matching.zexperiment;

import gnu.trove.map.hash.THashMap;

import java.util.Map;

import org.processmining.framework.util.collection.MultiSet;
import org.processmining.xlu.experiment.discovery.MarkedPetrinet;
import org.processmining.xlu.matching.zexperiment.precision.MapTrcEnabled;

public class ModelQuality {

	
	public static String LOG_PREC = "NormPr(ABS)";
	public static String LOG_PREC_TO_UB = "NormToImpr";
	public static String SYS_PREC_TO_LB = "SysPr(ABS)";
	public static String SYS_PREC_TO_UB = "SysPrecToImpr";
	
	public static final String SYS_PREC_LB = "SysPrecBase";
	public static String LOG_PREC_LB = "LogPrecBase";
	
	
	public double fitness = 0.0;
	public double precision = 0.0;
	public double generalisation = 0.0;

	public MarkedPetrinet net;

	public Map<String, Integer> mapTypeMove2Num = new THashMap<>();
	public Map<String, String> properties = new THashMap<>();
	
	public double precisionDistinctlabels;
	public double precisionDistinctlabelsTau;
	
	
	/**
	 * 
	 */
	public MapTrcEnabled mapTrcEnable;
	public double precWrtMGen = 0.0;
	public double recallWrtMGen = 0.0;
	
	public Map<String, MultiSet<String>> mapEvtClass2Set;
	private boolean isImproved = true;
	
	public boolean isImproved() {
		return isImproved;
	}

	public Map<String, MultiSet<String>> getMapEvtClass2Set() {
		return mapEvtClass2Set;
	}

	public void setMapEvtClass2Set(Map<String, MultiSet<String>> mapEvtClass2Set) {
		this.mapEvtClass2Set = mapEvtClass2Set;
	}

	public MapTrcEnabled getMapTrcEnable() {
		return mapTrcEnable;
	}

	public void setMarkedNet(MarkedPetrinet markedPetrinet) {
		net = markedPetrinet;

	}

	public void set(String string, int num) {
		// TODO Auto-generated method stub
		this.mapTypeMove2Num.put(string, num);
//		quality.set("numSM", numSM);
//		quality.set("numMM", numMM);
//		quality.set("numLM", numLM);
//		quality.set("numMMinv", numMMinv);
	}

	public int getNumSM() {
		return this.mapTypeMove2Num.get("numSM");
	}

	public int getNumLM() {
		return this.mapTypeMove2Num.get("numLM");
	}

	public int getNumMM() {
		return this.mapTypeMove2Num.get("numMM");
	}

	public int getNumMMinv() {
		return this.mapTypeMove2Num.get("numMMinv");
	}

	public void addProperty(String key, String value) {
		properties.put(key, value);		
	}

	public Map<String, String> getProperties() {
		return properties;
	}

	public void setEnabledSet(MapTrcEnabled enabledSet) {
		this.mapTrcEnable = enabledSet;		
	}

	public void setImproved(boolean b) {
		this.isImproved  = b;
		
	}
	
	

}
//trueLabelAttr = XExperimentNoiseExtension.getTrueLabelAttr(label);

//package org.processmining.xlu.experiment.mu;
//
//import java.util.Arrays;
//
//import org.deckfour.xes.extension.std.XConceptExtension;
//import org.deckfour.xes.factory.XFactory;
//import org.deckfour.xes.factory.XFactoryRegistry;
//import org.deckfour.xes.model.XAttribute;
//import org.deckfour.xes.model.XAttributeLiteral;
//import org.deckfour.xes.model.XEvent;
//import org.deckfour.xes.model.XLog;
//import org.deckfour.xes.model.XTrace;
//import org.processmining.xlu.experiment.alignment.XExperimentNoiseExtension;
//
//public class MUDATAPreprocess {
//
//	public static String[] MU_Noises = new String[] { "1e consult algemeen", "Vervolgconsult algemeen" };
//	public static String[] MU_RENAME_TEST = new String[] { "Na OK consult",
//		"1e_oogl.-extracaps.extract. impl.lens a.o.k", "Na 2eOK consult",
//		"2e_oogl.-extracaps.extract. impl.lens a.o.k",
//		"2e_ooglens-cataractop.extracaps.inbr.kunstl", "1e_ooglens-cataractop.extracaps.inbr.kunstl",
//		"Oog meting consult" };
//	
//	public static String[] MU_TEST = new String[] {"cornea-corneatopografie", "retina-OCT", "oog-IOL-master"};
//	
//	public static void updateMUDataLog(XLog log) {
//		XFactory factory = XFactoryRegistry.instance().currentDefault();
//		for (XTrace t : log) {
//			
//			boolean testConsults = false;
//			for (int i = 0; i < t.size(); i++) {
//				XEvent event = t.get(i);
//
//				// Needed to rename "Consulting" events to be mapped to each other...
//				XAttribute a = event.getAttributes().get("Verrichttekst_1");
////				if (a instanceof XAttributeLiteral) {
////					String label = ((XAttributeLiteral) a).getValue();
////					if (label.equals("1e consult algemeen")) {
////						XAttribute newA = factory.createAttributeLiteral("Verrichttekst_1", "Vervolgconsult algemeen",
////								null);
////						event.getAttributes().put(newA.getKey(), newA);
////					}
////				}
//
//				// Using XExperimentNoiseExtension to create the TRUE attributes for TP evaluations
//				String label = XConceptExtension.instance().extractName(event);
//				XAttribute trueLabelAttr = null;
//				if (label.equals(MU_Noises[0]) || label.equals(MU_Noises[1])) {
//					trueLabelAttr = XExperimentNoiseExtension.getTrueNoiseAttr();
//				} else {
//					
//					if (Arrays.asList(MU_RENAME_TEST).contains(label)) {
//						testConsults = true;
//					} else if (Arrays.asList(MU_TEST).contains(label)){
//						if(testConsults){
//							trueLabelAttr = XExperimentNoiseExtension.getTrueNoiseAttr();
//						}
//					}
//				}
//				if(trueLabelAttr == null){
//					trueLabelAttr = XExperimentNoiseExtension.
//				}
//				event.getAttributes().put(trueLabelAttr.getKey(), trueLabelAttr);
//			}
//		}
//
//	}
//}

