package org.processmining.xlu.matching.zexperiment.precision;

import gnu.trove.set.hash.THashSet;

import java.util.Collection;
import java.util.Set;

import org.apache.commons.lang3.StringUtils;
import org.processmining.models.graphbased.directed.petrinet.elements.Transition;

public class EnabledSet {

	Set<Transition> enabledSet;

	public EnabledSet(Collection<Transition> executableTransitions) {
		enabledSet = new THashSet<>(executableTransitions);
	}

	public int size() {

		return enabledSet.size();
	}

	public Set<Transition> getInvisibleTransitions() {
		Set<Transition> ts = new THashSet<Transition>();
		for (Transition t : enabledSet) {
			if (t.isInvisible()) {
				ts.add(t);
			}
		}
		return ts;
	}

	public Set<Transition> getAllEnabled() {
		return enabledSet;
	}

	public void addAll(Set<Transition> allEnabled) {
		enabledSet.addAll(allEnabled);
		
	}

	public String toString(){
		return "(" + StringUtils.join(this.enabledSet, ", ") + ")";
	}

	public Set<Transition> getVisibleTransitions() {
		Set<Transition> ts = new THashSet<Transition>();
		for (Transition t : enabledSet) {
			if (!t.isInvisible()) {
				ts.add(t);
			}
		}
		return ts;
	}
	
	public String getVisibleSetToString() {
		return StringUtils.join(this.getVisibleTransitions(), ", ");
	}
}
