package org.processmining.xlu.matching.zexperiment.precision;

import gnu.trove.map.hash.THashMap;

import java.util.Arrays;
import java.util.List;
import java.util.Map;
import java.util.Map.Entry;

import org.processmining.partialorder.models.palignment.Move;

public class MapTrcEnabled extends THashMap<Integer, Map<Move, EnabledSet>> {

	/**
	 * Returns a list of sets of possible alternatives. res[i] = the set of
	 * possible alternative for event "trace[i]"
	 * 
	 * @param traceIdx
	 * @param listSize
	 * @return
	 */
	public List<EnabledSet> getEnabledTraceList(int traceIdx, int listSize) {
//		List<EnabledSet> list = new ArrayList<EnabledSet>();

		Map<Move, EnabledSet> system2Set = this.get(traceIdx);

		EnabledSet[] list = new EnabledSet[listSize];
		for (Entry<Move, EnabledSet> entry : system2Set.entrySet()) {
			int eventIndex = entry.getKey().getEventIndex();
			if (eventIndex >= 0) {
//				list.set(eventIndex, entry.getValue());
				list[eventIndex] = entry.getValue();
			}
		}
		return Arrays.asList(list);
	}

	
//	public List<EnabledSet> getEnabledTraceListInv(int traceIdx, int listSize) {
////		List<EnabledSet> list = new ArrayList<EnabledSet>();
//
//		Map<Move, EnabledSet> system2Set = this.get(traceIdx);
//
//		Move[] list = new Move[system2Set.size()];
//		for (Entry<Move, EnabledSet> entry : system2Set.entrySet()) {
//			int moveIndex = entry.getKey().getMoveIndex();
////			if (eventIndex >= 0) {
////				list.set(eventIndex, entry.getValue());
//				list[moveIndex] = entry.getKey();
////			}
//		}
////		EnabledSet set = new EnabledSet()
//		for(int i = 1; i < list.length; i++){
//			
//		}
//		return Arrays.asList(list);
//	}
}
