package org.processmining.xlu.partialorder.comparison.vis;

import java.util.Collection;
import java.util.HashMap;
import java.util.Map;
import java.util.Map.Entry;

import org.processmining.partialorder.models.graph.POEdge;
import org.processmining.partialorder.models.graph.PONode;
import org.processmining.partialorder.models.graph.PartialOrderGraph;
import org.processmining.xlu.matching.models.RepEGraph;
import org.processmining.xlu.pgraph.vis.panel.PGraphInfoView;

public class PGraphInfoViewComparableGImp extends PGraphInfoView<RepEGraph> {
	Map<Object, Map<String, String>> infoMap = new HashMap<Object, Map<String, String>>();

	/**
	 * 
	 */
	private static final long serialVersionUID = -4701500393224135247L;

	public PGraphInfoViewComparableGImp(PartialOrderGraph g, RepEGraph object,
			Map<Object, Map<String, String>> map) {
		super(g, object);
		this.infoMap = map;
	}

	public void updateInfo(POEdge edge) {
		updateInfoGeneral(edge);
	}

	public void updateInfo(PONode node) {
		updateInfoGeneral(node);
	}

	private void updateInfoGeneral(Object o) {
		Map<String, String> info = this.infoMap.get(o);
		if (info == null) {
			info = new HashMap<>();
		}
		Object[][] infoArray = Util.convertMapToArray(info);
		this.tableModel.setDataVector(infoArray, columnNames);
	}

	/** this update graph info */
	public void updateGraphGeneralInfo() {
		Collection<Integer> ids = object.getRepresentedGraphIds();

		Map<String, Integer> costs = object.getCosts();
		if (costs == null) {
			costs = new HashMap<String, Integer>();
		}
		int numberOfRowsInTable = 3 + ids.size() + costs.size();
		Object[][] data = new Object[numberOfRowsInTable][2];
		int index = 0;
		data[index][0] = "Cluster";
		data[index][1] = object.getId();
		index++;

		data[index][0] = "Number of traces";
		data[index][1] = ids.size();
		index++;
		data[index][0] = "";
		data[index][1] = "";
		index++;
		
		for (Integer i : object.getRepresentedGraphIds()) {
			data[index][0] = "Trace";
			data[index][1] = i;
			index++;
		}
		int j = ids.size();
		for (Entry<String, Integer> entry : costs.entrySet()) {
			data[j][0] = entry.getKey();
			data[j][1] = entry.getValue();
			j++;
		}
		this.tableModel.setDataVector(data, columnNames);
	}

}
