package org.processmining.xlu.pgraph.vis.filter;

import javax.swing.JComponent;

import org.processmining.xlu.matching.models.ENode;
import org.processmining.xlu.matching.models.RepEGraph;

public class PGraphFilterEventFreqSingleGraphImpl implements PGraphFilter<ENode> {
	private RepEGraph graph;
	private int max;
	private int threshold = 40;


	public PGraphFilterEventFreqSingleGraphImpl(RepEGraph sourceREG) {
		graph = sourceREG;
		initialize();
	}
	
	public void initialize() {
		max = PGraphFilterEventFreqImpl.computeMaxFreq(graph);
	}

	public boolean isSatisfied(ENode object) {
		int ratio = graph.getNodeRepresentedNodes().get(object.getId()).size() * 100 / max;
		if (ratio >= threshold) {
			return true;
		}
		return false;
	}

	
	public int getThreshold() {
		return threshold;
	}

	public void setThreshold(int threshold) {
		this.threshold = threshold;
	}




	public JComponent getVisualPanel() {
		// TODO Auto-generated method stub
		return null;
	}

}
