package org.processmining.xlu.pgraph.vis.filter;

import java.util.HashMap;
import java.util.Map;

import javax.swing.JComponent;

import org.processmining.xlu.matching.models.ENode;
import org.processmining.xlu.matching.models.RepEGraph;

public class PGraphFilterLabelAEventFreqSingleGraphImpl implements PGraphFilter<ENode> {
	private RepEGraph graph;
	private Map<String, Integer> mapLabel2Max;
	private int threshold = 80;


	public PGraphFilterLabelAEventFreqSingleGraphImpl(RepEGraph sourceREG) {
		graph = sourceREG;
		mapLabel2Max = new HashMap<String, Integer>();
		initialize();
	}
	
	public void initialize() {
		mapLabel2Max = PGraphFilterLabelAEventFreqImpl.getLabelToFreqMap(graph);
		
	}


	public boolean isSatisfied(ENode object) {
		int ratio = graph.getNodeRepresentedNodes().get(object.getId()).size() * 100 / mapLabel2Max.get(object.getLabel());
		if (ratio >= threshold) {
			return true;
		}
		return false;
	}

	
	public int getThreshold() {
		return threshold;
	}

	public void setThreshold(int threshold) {
		this.threshold = threshold;
	}




	public JComponent getVisualPanel() {
		// TODO Auto-generated method stub
		return null;
	}
}
