package org.processmining.xlu.pgraph.vis.filter;

import javax.swing.JComponent;

import org.processmining.xlu.pgraph.vis.PGraphController;
import org.processmining.xlu.pgraph.vis.filter.panel.FilterViewMaxNumber;

public class PGraphFilterMaxNumber<T> extends PGraphFilterAbstract<T> {

	// data
	private int numberChecked = 0;
	private int maxNumber = 10;
	
	// vis
	private FilterViewMaxNumber panel;
	
	
	public PGraphFilterMaxNumber(PGraphController<?> controller){
		super(controller);
		numberChecked = 0;
	}
	
	public boolean isSatisfied(T object) {
		if(numberChecked < maxNumber){
			numberChecked++;
			return true;
		}
		return false;
	}


	public int getMaxNumber() {
		return maxNumber;
	}

	public void setMaxNumber(int maxNumber) {
		this.maxNumber = maxNumber;
		initialize();
		controller.update();
	}


	public JComponent getVisualPanel() {
		if(panel == null){
			this.panel = new FilterViewMaxNumber(this);
		}
		return panel;
	}

	public void initialize() {
		numberChecked = 0;
		
	}
	
	

}
