package org.processmining.xlu.pgraph.vis.filter;

import java.awt.BorderLayout;
import java.util.ArrayList;
import java.util.HashSet;
import java.util.List;
import java.util.Set;

import javax.swing.JComponent;
import javax.swing.JList;
import javax.swing.JPanel;
import javax.swing.ListSelectionModel;
import javax.swing.event.ListSelectionEvent;
import javax.swing.event.ListSelectionListener;

import org.processmining.partialorder.plugins.vis.projection.PProjectionConfigPanel;
import org.processmining.xlu.matching.models.RepEGraph;
import org.processmining.xlu.pgraph.vis.PGraphController;

public class PGraphFilterSourceIdImpl extends PGraphFilterAbstract<RepEGraph> {
	private Set<Integer> selectedIds = new HashSet<>();
	private List<Integer> ids = new ArrayList<>();

	private JPanel panel;

	public PGraphFilterSourceIdImpl(PGraphController<?> controller, Set<Integer> sourceGraphIds) {
		super(controller);
		ids = new ArrayList<Integer>(sourceGraphIds);
	}

	public boolean isSatisfied(RepEGraph object) {
		

		return  object.getRepresentedGraphIds().containsAll(selectedIds);
	}

	public void initialize() {
		// TODO Auto-generated method stub

	}

	public JComponent getVisualPanel() {
		if (panel == null) {
			panel = new JPanel();
			panel.setLayout(new BorderLayout());

			final JList<Integer> list = new JList<Integer>(ids.toArray(new Integer[ids.size()]));
//			list.setSelectionMode(ListSelectionModel.MULTIPLE_INTERVAL_SELECTION);
			list.getSelectionModel().addListSelectionListener(new ListSelectionListener() {

				@SuppressWarnings("unchecked")
				public void valueChanged(ListSelectionEvent e) {
					if (e.getValueIsAdjusting() == false) {
						ListSelectionModel lsm = (ListSelectionModel) e.getSource();

						int firstIndex = e.getFirstIndex();
						int lastIndex = e.getLastIndex();
//						boolean isAdjusting = e.getValueIsAdjusting();

						if (lsm.isSelectionEmpty()) {

						} else {
							// Find out which indexes are selected.
//							int minIndex = lsm.getMinSelectionIndex();
//							int maxIndex = lsm.getMaxSelectionIndex();
							for (int i = firstIndex; i <= lastIndex; i++) {
								if (lsm.isSelectedIndex(i)) {
									selectedIds.add(ids.get(i));
								} else {
									selectedIds.remove(ids.get(i));
								}
							}
							controller.update();
						}
					}
				}
			});
			JComponent comp = PProjectionConfigPanel.configureMultiSelectionList(list, "Select EGraphs", "Visualize ");
			//			list.setCellRenderer(new SelectedListCellRenderer());
			panel.add(comp, BorderLayout.CENTER);
		}
		return panel;
	}

}
