package org.processmining.xlu.pgraph.vis.filter;

import java.util.HashSet;
import java.util.Set;

import javax.swing.JComponent;

import org.processmining.xlu.matching.models.RepEGraph;
import org.processmining.xlu.pgraph.vis.PGraphController;
import org.processmining.xlu.pgraph.vis.filter.panel.FilterViewTraceId;

public class PGraphFilterTraceId extends PGraphFilterAbstract<RepEGraph> {

	// data
	private Set<Integer> selectedTraceIds = new HashSet<Integer>();

	// control
	

	private FilterViewTraceId panel;

	public PGraphFilterTraceId(PGraphController controller, Set<Integer> availableIds) {
		super(controller);
		this.panel = new FilterViewTraceId(this, availableIds);
	}

	public boolean isSatisfied(RepEGraph graph) {
		for (Integer id : graph.getRepresentedGraphIds()) {
			if (getSelectedTraceIds().contains(id)) {
				return true;
			}
		}
		return false;
	}

	public JComponent getVisualPanel() {
		return panel;
	}

	public Set<Integer> getSelectedTraceIds() {
		return selectedTraceIds;
	}

	public void setSelectedTraceIds(Set<Integer> selectedTraceIds) {
		this.selectedTraceIds = selectedTraceIds;
		controller.update();
	}

	public void initialize() {
		// skip?
		
	}

}
