package org.processmining.xlu.pgraph.vis.panel;

import java.awt.BorderLayout;
import java.awt.Dimension;

import javax.swing.JComponent;
import javax.swing.table.DefaultTableModel;

import org.processmining.framework.util.ui.widgets.ProMTable;
import org.processmining.partialorder.models.graph.POEdge;
import org.processmining.partialorder.models.graph.PONode;
import org.processmining.partialorder.models.graph.PartialOrderGraph;

public abstract class PGraphInfoView<T> extends JComponent {

	/**
	 * 
	 */
	private static final long serialVersionUID = -1991187131035571244L;

	protected PartialOrderGraph g;
	protected T object;
	protected DefaultTableModel tableModel;

	protected static Object[] columnNames = new Object[] { "Property", "Value" };

	public PGraphInfoView(PartialOrderGraph g, T object) {
		setLayout(new BorderLayout());

		this.g = g;
		this.object = object;

		tableModel = new DefaultTableModel() {

			@Override
			public boolean isCellEditable(int row, int column) {
				//all cells false
				return false;
			}
		};
//		
		ProMTable promTable = new ProMTable(tableModel);
		promTable.setMinimumSize(new Dimension(200, 100));
//		System.out.println(this.g.getSize());
		this.setMaximumSize(new Dimension(400, 300));
		this.setPreferredSize(new Dimension(300, 300));
//
		this.add(promTable, BorderLayout.CENTER);
		updateGraphGeneralInfo();
	}

	public void updateInfo(POEdge edge) {
		this.tableModel.setDataVector(edge.getInfo(), columnNames);
	}

	public void updateInfo(PONode node) {
		this.tableModel.setDataVector(node.getInfo(), columnNames);
	}

	public abstract void updateGraphGeneralInfo();

}
