package org.processmining.xlu.relabel.experiment;

import gnu.trove.map.hash.THashMap;
import gnu.trove.set.hash.THashSet;

import java.util.ArrayList;
import java.util.List;
import java.util.Map;
import java.util.Set;

public class ExpImprLabelPair<T> implements ExpImprLabelSetI<T> {

	private Set<T> nodeA;
	private T nodeB;

	private T minimalSharedParent;

	private Map<T, List<T>> pathToA = new THashMap<T, List<T>>();
	private List<T> pathToB = new ArrayList<T>();
	private List<T> pathToRoot = new ArrayList<T>();

	public ExpImprLabelPair(T taskA, T taskB) {
		this.nodeA = new THashSet<>();
		this.nodeA.add(taskA);
		this.nodeB = taskB;
	}

	public ExpImprLabelPair() {
		this.nodeA = new THashSet<>();
	}

	public ExpImprLabelPair(T[] nodeAs, T nodeB) {
		this.nodeA = new THashSet<>();
		for (int i = 0; i < nodeAs.length; i++) {
			if (!nodeAs[i].equals("")) {
				this.nodeA.add(nodeAs[i]);
			}
		}
//		this.nodeA.
		if (!nodeB.equals("")) {
			this.nodeB = nodeB;
		}
	}

	/* (non-Javadoc)
	 * @see org.processmining.xlu.relabel.experiment.ExpImprLabelPairI#getNodeA()
	 */
//	@Override
	public Set<T> getNodeAs() {
		return nodeA;
	}

	/**
	 * This function clears the current set of nodes and adds nodeA to the empty
	 * set.
	 * 
	 * @param nodeA
	 */
	public void setNodeA(T nodeA) {
		this.nodeA.clear();
		this.nodeA.add(nodeA);
	}

	public void setNodeA(Set<T> node) {
		this.nodeA.clear();
		this.nodeA.addAll(node);
	}

	/* (non-Javadoc)
	 * @see org.processmining.xlu.relabel.experiment.ExpImprLabelPairI#getNodeB()
	 */
	@Override
	public T getNodeB() {
		return nodeB;
	}

	public void setNodeB(T nodeB) {
		this.nodeB = nodeB;
	}

	/* (non-Javadoc)
	 * @see org.processmining.xlu.relabel.experiment.ExpImprLabelPairI#getMinimalSharedParent()
	 */
	@Override
	public T getMinimalSharedParent() {
		return minimalSharedParent;
	}

	public void setMinimalSharedParent(T minimalSharedParent) {
		this.minimalSharedParent = minimalSharedParent;
	}

	/* (non-Javadoc)
	 * @see org.processmining.xlu.relabel.experiment.ExpImprLabelPairI#getPathToA()
	 */
	@Override
	public Map<T, List<T>> getPathToA() {
		return pathToA;
	}

	public void setPathToA(T a, List<T> pathToA) {
		this.pathToA.clear();
		this.pathToA.put(a, pathToA);
	}

	/* (non-Javadoc)
	 * @see org.processmining.xlu.relabel.experiment.ExpImprLabelPairI#getPathToB()
	 */
	@Override
	public List<T> getPathToB() {
		return pathToB;
	}

	public void setPathToB(List<T> pathToB) {
		this.pathToB = pathToB;
	}

	/* (non-Javadoc)
	 * @see org.processmining.xlu.relabel.experiment.ExpImprLabelPairI#getPathToRoot()
	 */
	@Override
	public List<T> getPathToRoot() {
		return pathToRoot;
	}

	public void setPathToRoot(List<T> pathToRoot) {
		this.pathToRoot = pathToRoot;
	}

}
