package org.processmining.xlu.relabel.experiment;

import gnu.trove.map.hash.THashMap;

import java.util.Map;

import org.deckfour.xes.model.XLog;
import org.deckfour.xes.model.XTrace;

public class LogProperties {
	
	public enum LogProperty {
		NUM_TRACES("numTraces"), NUM_EVENTS("numEvents"), MAX_TRACE_LENGTH("maxTrSize");
		
	    private final String text;

	    private LogProperty(final String text) {
	        this.text = text;
	    }

	    public String toString() {
	        return text;
	    }

	}
	private Map<Object, Object> properties;
	

	public Map<Object, Object> getProperties() {
		return properties;
	}


	public void setProperties(Map<Object, Object> properties) {
		this.properties = properties;
	}


	public LogProperties(XLog log) {
		this.properties = new THashMap<Object, Object>();
		
		this.properties.put(LogProperty.NUM_TRACES, log.size());
		int numEvents = 0;
		int maxTraceSize = 0;
		for(XTrace t : log){
			numEvents += t.size();
			maxTraceSize = t.size() > maxTraceSize ? t.size() : maxTraceSize;
		}
		
		this.properties.put(LogProperty.NUM_EVENTS, numEvents);
		this.properties.put(LogProperty.MAX_TRACE_LENGTH, maxTraceSize);
		
	}


	public LogProperties() {
		this.properties = new THashMap<Object, Object>();
		
	}

}
