package org.processmining.xlu.relabel.experiment;

import gnu.trove.map.hash.THashMap;

import java.util.ArrayList;
import java.util.List;
import java.util.Map;

import org.apache.commons.lang3.StringUtils;
import org.processmining.partialorder.models.palignment.Move;
import org.processmining.xlu.experiment.discovery.ExpDiscoveryAlgorithm;
import org.processmining.xlu.matching.zexperiment.ModelQuality;
import org.processmining.xlu.matching.zexperiment.precision.EnabledSet;
import org.processmining.xlu.matching.zexperiment.precision.MapTrcEnabled;

public class OverviewMap {

	List<String> orderingResult = new ArrayList<>();
	
	
	Map<String, ModelQuality> mapAlg2Result = new THashMap<>();
	
	
	
	
	
	public void put(String string, ExpDiscoveryAlgorithm alg, ModelQuality mapTrcEnable) {
		String name = string + "_" + alg.toString();
		orderingResult.add(name);
		mapAlg2Result.put(name, mapTrcEnable);
	}

	public void put(String string, ModelQuality mapTrcEnabled) {
		String name = string;
		orderingResult.add(name);
		mapAlg2Result.put(name, mapTrcEnabled);
		
	}

	/**
	 * Gather for each algorithm, the trace list of possible firings. 
	 * Put them in a list according to orderingResult
	 * 
	 * @param traceIdx
	 * @param traceSize
	 * @return
	 */
	public List<List<EnabledSet>> getListOfListEnabledSet(int traceIdx, int traceSize) {
		List<List<EnabledSet>> res = new ArrayList<>();
		for(String s : orderingResult){
			MapTrcEnabled map = mapAlg2Result.get(s).mapTrcEnable;
			
			res.add(map.getEnabledTraceList(traceIdx, traceSize));
		}
		return res;
	}

	public String getListOfAlgsToString() {
		return StringUtils.join(this.orderingResult, ";");
	}

	public EnabledSet getMapTrcEnabled(int i) {
		
		return null;
	}

	public Map<Move, EnabledSet> getMapTrcEnabled(int algIndex, int trcIndex) {
		return mapAlg2Result.get(orderingResult.get(algIndex)).getMapTrcEnable().get(trcIndex);
	}

	public List<String> getListOfAlgs() {
		return this.orderingResult;
	}

	public ModelQuality getModelQuality(String alg) {
		return mapAlg2Result.get(alg);
	}

}
