package org.processmining.xlu.relabel.model;

import java.util.Map;
import java.util.Set;

import org.deckfour.xes.classification.XEventClass;
import org.deckfour.xes.model.XLog;
import org.processmining.plugins.InductiveMiner.graphs.Graph;
import org.processmining.xlu.matching.models.collection.EGraphsWithMappings;
import org.processmining.xlu.matching.models.collection.RepEGraphs;
import org.processmining.xlu.relabel.plugin.matching.EGraphMappingsInfo;

import gnu.trove.map.hash.THashMap;

public class RelabelModel {

	private Map<XEventClass, Graph<TEvent>> mapLabel2Graph = new THashMap<>();
	//	@Deprecated
	//	private Map<XEventClass, Cluster> mapLabel2Cluster = new THashMap<XEventClass, Cluster>();
	private XLog origLog;
	private Set<String> relabels;
	private Map<Integer, Integer> mapTrc2Cls;
	private RepEGraphs repgraphs;
	private EGraphsWithMappings mappings;
	private EGraphMappingsInfo info;
	private Graph<Integer> traceGraph;

	public Map<XEventClass, Graph<TEvent>> getMapLabel2Graph() {
		return mapLabel2Graph;
	}

	public void setMapLabel2Graph(Map<XEventClass, Graph<TEvent>> mapLabel2Graph) {
		this.mapLabel2Graph = mapLabel2Graph;
	}

	public XLog getOrigLog() {
		return origLog;
	}

	public void setOrigLog(XLog origLog) {
		this.origLog = origLog;
	}

	public void setMapTrcToCls(Map<Integer, Integer> mapTrcId2ClsId) {
		this.mapTrc2Cls = mapTrcId2ClsId;
	}

	public Map<Integer, Integer> getMapTrcToCls() {
		return mapTrc2Cls;
	}

	public void setClasses(Set<String> classes) {
		this.relabels = classes;
	}

	public Set<String> getClasses() {
		return this.relabels;
	}

	public void setGraphs(RepEGraphs repgraphs) {
		this.repgraphs = repgraphs;
	}

	public RepEGraphs getGraphs() {
		return repgraphs;
	}

	public void setMappings(EGraphsWithMappings mapGraphsToMapping) {
		this.mappings = mapGraphsToMapping;
	}

	public EGraphsWithMappings getMappings() {
		return this.mappings;
	}

	public void setMappingsInfo(EGraphMappingsInfo info) {
		this.info = info;
	}

	public EGraphMappingsInfo getMappingsInfo() {
		return info;
	}

	public void setTraceGraph(Graph<Integer> traceGraph) {
		this.traceGraph = traceGraph;
	}

	public Graph<Integer> getTraceGraph() {
		return traceGraph;
	}

}
