package org.processmining.xlu.relabel.param;

import org.deckfour.xes.classification.XEventClassifier;
import org.processmining.xlu.relabel.plugin.matching.ClusterRefiner;
import org.processmining.xlu.relabel.plugin.matching.ClusterRefinerParam;
import org.processmining.xlu.relabel.plugin.matching.ClusterRefinerUsingMatching;
import org.processmining.xlu.relabel.plugin.matching.LabelRefiner;
import org.processmining.xlu.relabel.plugin.matching.LabelRefinerParam;
import org.processmining.xlu.relabel.plugin.matching.LabelRefinerUsingMatching;
import org.processmining.xlu.relabel.plugin.matching.ModelCreator;
import org.processmining.xlu.relabel.plugin.matching.ModelCreatorParam;
import org.processmining.xlu.relabel.plugin.matching.ModelCreatorUsingMatching;

public class RelabelCoreParam {

	private XEventClassifier classifier;
	
	private ModelCreator relabeler;
	private ModelCreatorParam relabelerParam;
	
	private ClusterRefiner clusterMethod;
	private ClusterRefinerParam clusterParam;
	
	private LabelRefiner relabelMethod;
	private LabelRefinerParam relabelParam;
	
	public static RelabelCoreParam createDefaultRelabelCoreParam() {
		RelabelCoreParam param = new RelabelCoreParam();
		setDefaultRelabelCoreParam(param);
		return param;
	}

	public static void setDefaultRelabelCoreParam(RelabelCoreParam param){
		param.setRelabeler(new ModelCreatorUsingMatching());
		param.setRelabelerParam(new ModelCreatorParam());

		param.setClusterMethod(new ClusterRefinerUsingMatching());
		param.setClusterParam(new ClusterRefinerParam());

		param.setRelabelMethod(new LabelRefinerUsingMatching());
		param.setRelabelParam(new LabelRefinerParam());
	}


	public ClusterRefiner getClusterMethod() {
		return this.clusterMethod;
	}

	public void setClusterMethod(ClusterRefiner clusterMethod) {
		this.clusterMethod = clusterMethod;
	}

	public LabelRefiner getRelabelMethod() {
		return relabelMethod;
	}

	public void setRelabelMethod(LabelRefiner relabelMethod) {
		this.relabelMethod = relabelMethod;
	}

	public XEventClassifier getClassifier() {
		return this.classifier;
	}

	public void setClassifier(XEventClassifier classifier) {
		this.classifier = classifier;
	}

	public ClusterRefinerParam getClusterParam() {
		return clusterParam;
	}

	public void setClusterParam(ClusterRefinerParam clusterParam) {
		this.clusterParam = clusterParam;
	}

	public LabelRefinerParam getRelabelParam() {
		return relabelParam;
	}

	public void setRelabelParam(LabelRefinerParam relabelParam) {
		this.relabelParam = relabelParam;
	}

	public ModelCreator getRelabeler() {
		return relabeler;
	}

	public void setRelabeler(ModelCreator relabeler) {
		this.relabeler = relabeler;
	}

	public ModelCreatorParam getRelabelerParam() {
		return relabelerParam;
	}
	
	public void setRelabelerParam(ModelCreatorParam relabelerParam) {
		this.relabelerParam = relabelerParam;
	}

}