package org.processmining.xlu.relabel.param;

import org.deckfour.xes.classification.XEventNameClassifier;
import org.processmining.processtree.Node;
import org.processmining.processtree.ProcessTree;
import org.processmining.xlu.relabel.plugin.detection.ILDetectorIMGlobal;
import org.processmining.xlu.relabel.plugin.detection.ILDetectorIMLocal;
import org.processmining.xlu.relabel.plugin.detection.ILDetectorIMParam;
import org.processmining.xlu.relabel.plugin.matching.ReplacerIMGlobal;
import org.processmining.xlu.relabel.plugin.matching.ReplacerIMLocal;

public class RelabelParamPT extends RelabelParam<ProcessTree, Node> {

	
	public static RelabelParamPT createLocalDefaultParam() {
		RelabelParamPT param = new RelabelParamPT();
		param.setClassifier(new XEventNameClassifier());

		param.setDetector(new ILDetectorIMLocal());
		param.setDetectorParam(new ILDetectorIMParam());

		setDefaultRelabelCoreParam(param);
		param.getRelabelParam().setMaxCostOfEdge(10);
	

		param.setReplacer(new ReplacerIMLocal());
//		param.setReplacer(new ReplacerIMGlobal());
		return param;
	}
	
	
	public static RelabelParamPT createGlobalDefaultParam() {
		RelabelParamPT param = new RelabelParamPT();
		param.setClassifier(new XEventNameClassifier());

		param.setDetector(new ILDetectorIMGlobal());
		param.setDetectorParam(new ILDetectorIMParam());

		setDefaultRelabelCoreParam(param);
		
//		param.getRelabelParam().setMaxCostOfEdge(1); // for size 25
		param.getRelabelParam().setMaxCostOfEdge(5);
		param.setReplacer(new ReplacerIMGlobal());

		return param;
	}


}
