package org.processmining.xlu.relabel.plugin;

import gnu.trove.set.hash.THashSet;

import java.util.ArrayList;
import java.util.List;
import java.util.Set;

import org.deckfour.xes.classification.XEventClassifier;
import org.deckfour.xes.model.XLog;
import org.processmining.plugins.InductiveMiner.mining.MiningParametersIM;
import org.processmining.plugins.InductiveMiner.plugins.IMProcessTree;
import org.processmining.processtree.Node;
import org.processmining.processtree.ProcessTree;
import org.processmining.xlu.relabel.plugin.detection.ILDetector;
import org.processmining.xlu.relabel.plugin.detection.ILDetectorParam;
import org.processmining.xlu.relabel.plugin.detection.RelabelScope;
import org.processmining.xlu.relabel.plugin.detection.RelabelScopePT;

public class ILDetectorExpert implements ILDetector<ProcessTree, Node> {

	private Set<String> impreciseLabels = new THashSet<String>();

	public ILDetectorExpert(String... impreciselabels) {
		super();
		for(String s : impreciselabels){
			impreciseLabels.add(s);
		}
	}

	public Set<String> getImpreciseLabels() {
		return impreciseLabels;
	}
	
	public void addImpreciseLabel(String s) {
		impreciseLabels.add(s);
	}

	public RelabelScope<ProcessTree, Node> detectImpreciseLabels(XLog log, ILDetectorParam param) {
			
	
	//		List<Type> operators = param.getSelectedOperators();
			XEventClassifier classifier = param.getClassifier();
	
			MiningParametersIM imParam = new MiningParametersIM();
			imParam.setClassifier(classifier);
			//Get a model. 
			ProcessTree tree = IMProcessTree.mineProcessTree(log, imParam);
	
			List<Node> selectedNodes = new ArrayList<Node>();
			for (Node n : tree.getNodes()) {
				if (impreciseLabels.contains(n.getName())) {
					selectedNodes.add(n);
				}
			}
	
			RelabelScopePT scope = RelabelScopePT.createScope(tree, tree.getRoot(),
					impreciseLabels, log, log);
	
			return scope;
		}



}