package org.processmining.xlu.relabel.plugin.detection;

import gnu.trove.set.hash.THashSet;

import java.util.ArrayList;
import java.util.List;
import java.util.Set;

import org.deckfour.xes.classification.XEventClassifier;
import org.deckfour.xes.model.XLog;
import org.processmining.plugins.InductiveMiner.mining.MiningParametersIM;
import org.processmining.plugins.InductiveMiner.plugins.IMProcessTree;
import org.processmining.processtree.Node;
import org.processmining.processtree.ProcessTree;

public class ExpILDetectorOracleGlobal implements ILDetector<ProcessTree, Node> {

	private Set<String> impreciseLabels = new THashSet<String>();

	public Set<String> getImpreciseLabels() {
		return impreciseLabels;
	}

	public void setImpreciseLabels(Set<String> impreciseLabels) {
		this.impreciseLabels = impreciseLabels;
	}

	public RelabelScope<ProcessTree, Node> detectImpreciseLabels(XLog log,
			ILDetectorParam param) {

//		List<Type> operators = param.getSelectedOperators();
		XEventClassifier classifier = param.getClassifier();

		MiningParametersIM imParam = new MiningParametersIM();
		imParam.setClassifier(classifier);
		//Get a model. 
		ProcessTree tree = IMProcessTree.mineProcessTree(log, imParam);

		List<Node> selectedNodes = new ArrayList<Node>();
		for (Node n : tree.getNodes()) {
			if (impreciseLabels.contains(n.getName())) {
				selectedNodes.add(n);
			}
		}

		RelabelScopePT scope = RelabelScopePT.createScope(tree, tree.getRoot(),
				impreciseLabels, log, log);

		return scope;
	}

	public void addImpreciseLabel(String nodeB) {
		impreciseLabels.add(nodeB);
	}

}
