package org.processmining.xlu.relabel.plugin.matching;

import java.util.Map;

import org.processmining.framework.util.collection.MultiSet;
import org.processmining.framework.util.collection.TreeMultiSet;
import org.processmining.xlu.matching.models.MatchMapping;
import org.processmining.xlu.matching.models.collection.EGraphsWithMappings;



public class EGraphMappingsInfo {

	private int max;
	private MultiSet<Integer> costDistribution;
	private Map<MatchMapping, Integer> mapToCost;



	public EGraphMappingsInfo(MultiSet<Integer> costDistribution, int max) {
		this.costDistribution = costDistribution;
		this.max = max;
	}

	public static EGraphMappingsInfo createMappingInfo(
			EGraphsWithMappings graphsWithMappings) {
		
		MultiSet<Integer> costDistribution = new TreeMultiSet<Integer>();		
		int size = graphsWithMappings.getPlog().size();
		
		int max = 0;
		for(int i = 0; i < size ; i++){
			for(int j = i+1; j<size; j++){
				MatchMapping m = graphsWithMappings.getMappings().getAnOptimalMapping(i, j);
				costDistribution.add(m.getCost());
				
				if(m.getCost() > max){
					max = m.getCost();
				}
				
			}
		}
		
//		java.util.Collections.sort(costDistribution);
		return new EGraphMappingsInfo(costDistribution, max);		
	}
	
	
	public int getMax() {
		return max;
	}

	public MultiSet<Integer> getCostDistribution() {
		return costDistribution;
	}

	public void setMapToCost(Map<MatchMapping, Integer> mapToNewCost) {
		this.mapToCost = mapToNewCost;
	}

	public Map<MatchMapping, Integer> getMapToCost() {
		return mapToCost;
	}
}
