package org.processmining.xlu.relabel.plugin.matching;

import java.util.Map;

import org.deckfour.xes.classification.XEventClass;

import gnu.trove.map.hash.THashMap;

public class LabelRefinerParam {
	
	private int unfoldingThreshold;
	private int maxCost;
	@Deprecated
	private Map<XEventClass, Integer> mapEvClass2NumClusters = new THashMap<>();
	
	public LabelRefinerParam() {
		this.unfoldingThreshold = 0;
		this.maxCost = 2;
	}
	
	public LabelRefinerParam(int unfoldingThreshold, int maxCost) {
		this.unfoldingThreshold = unfoldingThreshold;
		this.maxCost = maxCost;
	}


	public int getUnfoldingThreshold() {
		return unfoldingThreshold;
	}

	public void setUnfoldingThreshold(int unfoldingThreshold) {
		this.unfoldingThreshold = unfoldingThreshold;
	}

	public int getMaxCostOfEdge() {
		return maxCost;
	}

	public void setMaxCostOfEdge(int maxCost) {
		this.maxCost = maxCost;
	}


	public int getEventClassNum(XEventClass evClass) {
		Integer num = this.mapEvClass2NumClusters.get(evClass);
		return num != null ? num : 0;
	}

	public void setEventClassNumb(XEventClass evClass, int threshold) {
		mapEvClass2NumClusters.put(evClass, threshold);
	}

	public void reset() {
		this.maxCost = 5;		
		this.unfoldingThreshold = 60;
	}


}