package org.processmining.xlu.relabel.plugin.matching;

import java.util.Iterator;

import org.deckfour.xes.model.XLog;
import org.processmining.plugins.InductiveMiner.mining.MiningParametersIM;
import org.processmining.plugins.InductiveMiner.plugins.IMProcessTree;
import org.processmining.processtree.Block;
import org.processmining.processtree.Edge;
import org.processmining.processtree.Node;
import org.processmining.processtree.ProcessTree;
import org.processmining.processtree.impl.AbstractTask.Manual;
import org.processmining.xlu.relabel.plugin.detection.RelabelScope;

public class ReplacerIMLocal implements Replacer<ProcessTree, Node> {

	public ProcessTree rediscover(RelabelScope<ProcessTree, Node> scope, XLog refinedLog) {
		//Rediscover the sub model and replace the sub model. 
//		ProcessTree subtree = rediscover(refinedLog);

		MiningParametersIM imParam = new MiningParametersIM();
		ProcessTree subtree = IMProcessTree.mineProcessTree(refinedLog, imParam);
		changeTransitionLabels(subtree);

		ProcessTree tree = scope.getModel();
		replaceSubTree(tree, scope.getSubmodel(), subtree.getRoot());
		scope.setSubModel(subtree.getRoot());

		return tree;
	}

	public static void changeTransitionLabels(ProcessTree subtree) {
		for (Node n : subtree.getNodes()) {
			if (n instanceof Manual) {
				String label = ((Manual) n).getName();
				if (label.indexOf("_X_") > 0) {
					label = label.substring(0, label.indexOf("_X_"));
					n.setName(label);
				}
			}
		}
	}

	private void replaceSubTree(ProcessTree tree, Node originalSubTree, Node subtree) {
//		Node root = ;
		
		testTrees(originalSubTree, subtree);
		
		subtree.setProcessTree(tree);

		Iterator<Block> iterator = originalSubTree.getParents().iterator();
		if (!iterator.hasNext()) {
			tree.setRoot(subtree);

		} else {
			Block parentNode = iterator.next();
			for (Iterator<Edge> it = parentNode.getOutgoingEdges().iterator(); it
					.hasNext();) {
				Edge edge = it.next();
				if (edge.getTarget().equals(originalSubTree)) {
					edge.setTarget(subtree);
				}
			}
		}
	}

	private void testTrees(Node originalSubTree, Node subtree) {
		
		
	}

}
