package org.processmining.xlu.relabel.visualization;

import javax.swing.JComponent;

import org.deckfour.xes.model.XLog;
import org.processmining.contexts.uitopia.UIPluginContext;
import org.processmining.contexts.uitopia.annotations.UITopiaVariant;
import org.processmining.contexts.uitopia.annotations.Visualizer;
import org.processmining.framework.plugin.PluginContext;
import org.processmining.framework.plugin.annotations.Plugin;
import org.processmining.framework.plugin.annotations.PluginVariant;
import org.processmining.xlu.relabel.model.RelabelVisModel;
import org.processmining.xlu.relabel.plugin.RelabelInteractivePlugin;

public class RelabelInteractivePluginVisualizer {

	@Plugin(name = "Vis", returnLabels = { "vis" }, returnTypes = {
			JComponent.class }, parameterLabels = { "Event log" }, userAccessible = true)
	@Visualizer
	@UITopiaVariant(affiliation = UITopiaVariant.EHV, author = "x.lu", email = "x.lu@tue.nl")
	@PluginVariant(variantLabel = "vis", requiredParameterLabels = { 0 })
	public JComponent visualize(final UIPluginContext context, RelabelVisModel model) {

		RelabelMainPanel panel = new RelabelMainPanel(context, model);

		return panel;
	}

	public static RelabelMainPanel visualizeByCreateSeperateFrame(
			final PluginContext pluginContext, XLog newLog) {
		RelabelInteractivePlugin runner = new RelabelInteractivePlugin();
		RelabelVisModel model = runner.relabelLogGlobal(pluginContext, newLog);

		RelabelMainPanel panel = new RelabelMainPanel(pluginContext, model);

		return panel;
	}

}

//public class InductiveVisualMiner {
//
//	@Plugin(name = "Inductive visual Miner", returnLabels = { "Dot visualization" }, returnTypes = { JComponent.class }, parameterLabels = { "Event log" }, userAccessible = false)
//	@Visualizer
//	@UITopiaVariant(affiliation = UITopiaVariant.EHV, author = "S.J.J. Leemans", email = "s.j.j.leemans@tue.nl")
//	@PluginVariant(variantLabel = "Convert Process tree", requiredParameterLabels = { 0 })
//	public JComponent visualise(final UIPluginContext context, XLog xLog) {
//
//		InductiveVisualMinerState state = new InductiveVisualMinerState(xLog, null);
//		InductiveVisualMinerPanel panel = new InductiveVisualMinerPanel(context, state,
//				Classifiers.getClassifiers(xLog), VisualMinerWrapperPluginFinder.find(context, state.getMiner()), true);
//		new InductiveVisualMinerController(context, panel, state);
//
//		return panel;
//	}