package org.processmining.xlu.relabel.visualization;

import java.awt.Color;
import java.awt.Component;
import java.awt.event.ActionEvent;
import java.awt.event.ActionListener;

import javax.swing.BorderFactory;
import javax.swing.Box;
import javax.swing.BoxLayout;
import javax.swing.JComboBox;
import javax.swing.JComponent;
import javax.swing.JLabel;
import javax.swing.JPanel;
import javax.swing.border.Border;

import org.processmining.partialorder.plugins.vis.PartialVisualType;
import org.processmining.xlu.experiment.discovery.ExpDiscoveryInductiveMiner;

import com.fluxicon.slickerbox.factory.SlickerDecorator;

public class RelabelVisSetting {

//	private Object visType;

	private JComponent panel;

	private RelabelControllerModel controller;

	private RelabelMainPanel parent;

	private static Border paddingBorder = BorderFactory.createEmptyBorder(10, 10, 10, 10);

	public RelabelVisSetting(RelabelControllerModel controller, RelabelMainPanel parent) {
		this.controller = controller;
		this.parent = parent;
	}

	public JComponent getPanel() {
		if (panel == null) {
			panel = new JPanel();
			panel.setLayout(new BoxLayout(panel, BoxLayout.Y_AXIS));
			panel.setBackground(Color.DARK_GRAY);
			panel.setForeground(Color.WHITE);

			final JLabel labelVisType = RelabelMainPanel.createLabel(panel,
					"Set visualization type: ");
			Box boxContainer = Box.createHorizontalBox();
			boxContainer.add(labelVisType);
			boxContainer.add(Box.createHorizontalGlue());
			boxContainer.setAlignmentX(Component.LEFT_ALIGNMENT);
			panel.add(boxContainer);

			final JComboBox<Object> visCombo = new JComboBox<Object>(
					getAllPossibleVisTypes());

			SlickerDecorator.instance().decorate(visCombo);
			visCombo.setBackground(Color.DARK_GRAY);
			visCombo.setForeground(Color.WHITE);
			visCombo.setAlignmentX(Component.LEFT_ALIGNMENT);
			visCombo.addActionListener(new ActionListener() {

				public void actionPerformed(ActionEvent e) {
					controller.setVisType(visCombo.getSelectedItem());
					parent.updateNewModel();
				}
			});
			visCombo.setSelectedIndex(0);
			panel.add(visCombo);
		}
		return panel;
	}

	private Object[] getAllPossibleVisTypes() {
		PartialVisualType[] comparableGraphVisualType = PartialVisualType
				.toComparableGraphVisualType();
		int numVisTypes = 3;
		Object[] visTypes = new Object[numVisTypes];
		visTypes[0] = new ExpDiscoveryInductiveMiner();
//		visTypes[1] = new ExpDiscoveryHyberILP();

//		for(int i = 1; i < comparableGraphVisualType.length+1; i++){
		visTypes[1] = comparableGraphVisualType[1];
		visTypes[2] = "IvM (show deviations)";
//		}

		return visTypes;
	}

}
